package refactoringtestplugin.changereturntype;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class Demo extends ChangeReturnTypeTest {

	@Override
	public String getDescription() {
		return "Demo for ChangeReturnTypeTest";
	}
	
	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo"; 
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
			"package p; public class A { void m(){}}",
			"package p; public class A { Integer m(){return null;}}",
			"package p; public class A { Integer m(){return 1;}}",
			"package p; public class A { Boolean m(){return null;}}",
			"package p; public class A { Boolean m(){return false;}}",
			"package p; public class A { Object m(){return null;}}",
		};
			
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
		for (String source : sources) {
			parser.setSource(source.toCharArray());
			parser.setKind(ASTParser.K_COMPILATION_UNIT);
			cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
		}
		return cuGen;	
	}

}
