package refactoringtestplugin.commongenerators;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.eclipse.jdt.core.dom.SingleVariableDeclaration;
import org.eclipse.jdt.core.dom.Type;
import org.eclipse.jdt.core.dom.TypeDeclaration;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.astgen.ASTNodeLiteral;
import edu.uiuc.astgen.basic.CompilationUnitGenerator;
import edu.uiuc.astgen.basic.MethodDeclarationGenerator;
import edu.uiuc.astgen.methodrelationships.SingleClassMethodReferenceGenerator;
import org.testorrery.ConvertingGenerator;
import org.testorrery.IGenerator;

public class MethodReferences {
	private static AST ast = ASTNodeGeneratorBase.ast();
	
	public enum ExpectParameters {
		ONE,
		NONE,
		ZERO_OR_ONE;
	}
	
	public static IGenerator<CompilationUnit> singleClassMethodReference(ExpectParameters expectParams) {
		SingleVariableDeclaration param = ast.newSingleVariableDeclaration();
		param.setName(ast.newSimpleName("arg0"));
		param.setType(ast.newSimpleType(ast.newSimpleName("Object")));
		
		ASTNodeChain<SingleVariableDeclaration> paramChain = new ASTNodeChain<SingleVariableDeclaration>();
		if (expectParams != ExpectParameters.ONE) {
			paramChain.add(new ASTNodeLiteral<SingleVariableDeclaration>(null)); // no parameter
		}
		if (expectParams != ExpectParameters.NONE) {
			paramChain.add(param);		
		}
		
		ASTNodeChain<Type> returnTypeChain = new ASTNodeChain<Type>(
				ast.newPrimitiveType(PrimitiveType.VOID), 
				ast.newSimpleType(ast.newSimpleName("Integer")),
				ast.newSimpleType(ast.newSimpleName("Boolean")),
				ast.newSimpleType(ast.newSimpleName("Object")));
		
		MethodDeclarationGenerator methDeclGen = new MethodDeclarationGenerator("m"); 
		methDeclGen.addParameterGenerator(paramChain);
		methDeclGen.setReturnTypeGenerator(returnTypeChain);
		
		SingleClassMethodReferenceGenerator scmrg = new SingleClassMethodReferenceGenerator(methDeclGen);		
		
		CompilationUnitGenerator cuGen = new CompilationUnitGenerator();
		cuGen.addDeclarationGenerator(scmrg);
		return cuGen;
	}
}
