package refactoringtestplugin.commongenerators;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.Type;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.astgen.ASTNodeLiteral;
import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.basic.CompilationUnitGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.methodrelationships.MethodWithParameterReferenceGenerator;
import org.testorrery.IGenerator;

public class ParameterReferences {

	public static IGenerator<CompilationUnit> methodWithParameterReference(String methodName, String paramName) {
		AST ast = ASTNodeGeneratorBase.ast();
		SingleVariableDeclarationGenerator paramGen = new SingleVariableDeclarationGenerator(paramName);
		paramGen.setTypeGen(new ASTNodeChain<Type>(
				ast.newSimpleType(ast.newSimpleName("Integer")),
				ast.newSimpleType(ast.newSimpleName("Boolean")),
				ast.newSimpleType(ast.newSimpleName("Object"))));
		MethodWithParameterReferenceGenerator methDeclGen = new MethodWithParameterReferenceGenerator(methodName,paramGen);

		ClassGenerator classGen = new ClassGenerator("A");
		classGen.addBodyDeclarationGenerator(methDeclGen);
		
		CompilationUnitGenerator cuGen = new CompilationUnitGenerator();
		cuGen.addDeclarationGenerator(classGen);
		return cuGen;
	}
}
