package refactoringtestplugin.encapsulatefield;

import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.Modifier.ModifierKeyword;

import edu.uiuc.astgen.basic.ArrayFieldDeclarationGenerator;
import edu.uiuc.astgen.basic.ArrayTypeGenerator;
import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.basic.CompilationUnitGenerator;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import org.testorrery.IGenerator;
import org.testorrery.examples.IntegerRangeGenerator;


public class ClassWithArrayField extends EncapsulateFieldTest {
	
	@Override
	public String getDescription() {
		return "Encapsulate a field in Class A where the field has various array types. Refactor to encapsulate f.";
	}
	
	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/classwitharrayfield";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		ArrayTypeGenerator typeGen = new ArrayTypeGenerator();
		typeGen.setTypeGen(PrimitiveTypeGenerator.getAllTypes());
		typeGen.setSubscriptNumberGen(new IntegerRangeGenerator(0, 2));
				
		ArrayFieldDeclarationGenerator fieldDeclGen = new ArrayFieldDeclarationGenerator();
		fieldDeclGen.setTypeGen(typeGen);
		fieldDeclGen.setNameGen(new SimpleNameGenerator(FIELD_TO_REFACTOR));
		fieldDeclGen.setDimGen(new IntegerRangeGenerator(0, 2));
		
		ClassGenerator classGen = new ClassGenerator("A");
		classGen.setVisibilityModifierGen(new ModifierGenerator(ModifierKeyword.PUBLIC_KEYWORD));
		classGen.addBodyDeclarationGenerator(fieldDeclGen);
		
		CompilationUnitGenerator cuGen = new CompilationUnitGenerator();
		cuGen.addDeclarationGenerator(classGen);
		return cuGen;
	}
}
