package refactoringtestplugin.innertotop;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class Demo extends InnerToTopTest {
	
	@Override
	public String getDescription() {
		return "Demo";
	}

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo";
	}

	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
				"class A { class B {}}",
				"class A { int f; class B { int g = f; }}",
				// custom postcondition failure. purposefully only extracts the first
				"class A { class B {} class C {}",
			};
				
			ASTParser parser = ASTParser.newParser(AST.JLS3);
			Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
			for (String source : sources) {
				parser.setSource(source.toCharArray());
				parser.setKind(ASTParser.K_COMPILATION_UNIT);
				cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
			}
			return cuGen;	
	}

}
