package refactoringtestplugin.innertotop;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.Type;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;
import edu.uiuc.astgen.classrelationships.LocationType;
import edu.uiuc.astgen.classrelationships.RelationshipSpecificationGenerator;
import edu.uiuc.astgen.fieldreferences.DualClassFieldReferenceGenerator;
import org.testorrery.IGenerator;

public class DualClassFieldReference extends InnerToTopTest {

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/dualclassfieldreference";
	}
	
	@Override
	public String getDescription() {
		return "Two classes A and B. B is inner to A. A declares a field and B references it in some way. Refactor by moving B to the top level"; 
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		AST ast = ASTNodeGeneratorBase.ast();
		FieldDeclarationGenerator fieldDeclGen = new FieldDeclarationGenerator("f");
		fieldDeclGen.setTypeGen(new ASTNodeChain<Type>(
				ast.newSimpleType(ast.newSimpleName("Integer")),
				ast.newSimpleType(ast.newSimpleName("Boolean")),
				ast.newSimpleType(ast.newSimpleName("Object"))));
		
		RelationshipSpecificationGenerator relSpecGen = new RelationshipSpecificationGenerator();
		relSpecGen.setLocation(LocationType.INNER);
		relSpecGen.setEnableReverseLocation(false);
		relSpecGen.setInheritanceAll();
		relSpecGen.setEnableReverse(false);
		
		DualClassFieldReferenceGenerator cuGen = new DualClassFieldReferenceGenerator(fieldDeclGen);
		cuGen.setRelationshipSpecificationGen(relSpecGen);
		return cuGen;
	}



}
