package refactoringtestplugin.innertotop;

import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.internal.corext.refactoring.structure.MoveInnerToTopRefactoring;
import org.eclipse.jdt.internal.ui.preferences.JavaPreferencesSettings;
import org.eclipse.ltk.core.refactoring.Refactoring;

import refactoringtestplugin.ProblemReport;
import refactoringtestplugin.RefactoringTest;
import refactoringtestplugin.util.JavaProjectHelper;

public abstract class InnerToTopTest extends RefactoringTest {

	@Override
	protected String getLogDirPath() {
		return getSystemTempDir() + "/innertotop";
	}

	@Override
	protected Refactoring getRefactoring(ICompilationUnit icu) throws JavaModelException {
		MoveInnerToTopRefactoring refactoring = 
			new MoveInnerToTopRefactoring(
					getInnerType(icu), 
					JavaPreferencesSettings.getCodeGenerationSettings(getProject()));
		return refactoring;
	}

	private IType getInnerType(ICompilationUnit icu) throws JavaModelException {
		// first inner type of the first type in the CU	
		return icu.getTypes()[0].getTypes()[0];
	}
	
	@Override
	protected ProblemReport checkCustomPostconditions(ICompilationUnit icu) throws Exception {
		ProblemReport pr = new ProblemReport();
		if (icu.getTypes()[0].getTypes().length > 0) {
			pr.addProblem("Inner type was not moved");
		}
		return pr;
	}

}
