package refactoringtestplugin.movemethod;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class Demo extends MoveMethodTest {

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo";
	}

	@Override
	public String getDescription() {
		return "Demo";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
				// normal class
				"package p; class A {} class B {void m(A a) {}}",
				// inner class
				"package p; class A {class B {void m(A a) {}}}",
				// local class
				"package p; class A { void m() {class B {void m(A a) {}}}}",
			};
				
			ASTParser parser = ASTParser.newParser(AST.JLS3);
			Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
			for (String source : sources) {
				parser.setSource(source.toCharArray());
				parser.setKind(ASTParser.K_COMPILATION_UNIT);
				cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
			}
			return cuGen;	

	}


}
