package refactoringtestplugin.movemethod;

import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IMember;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IPackageDeclaration;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.internal.corext.refactoring.structure.MoveStaticMembersProcessor;
import org.eclipse.jdt.internal.ui.preferences.JavaPreferencesSettings;
import org.eclipse.ltk.core.refactoring.Refactoring;
import org.eclipse.ltk.core.refactoring.participants.MoveRefactoring;

import org.testorrery.IGenerator;
import refactoringtestplugin.RefactoringTest;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

public abstract class MoveMethodTest extends RefactoringTest {

	private static final String TARGET_CLASS_NAME = "B";
	private static final String TARGET_METHOD_NAME = "m";
	
	@Override
	protected String getLogDirPath() {
		return getSystemTempDir() + "/movemethod";
	}

	@Override
	protected Refactoring getRefactoring(ICompilationUnit icu) throws JavaModelException {
		// Under Development 4/16/07
		throw new NotImplementedException();
//		MoveStaticMembersProcessor processor = 
//			new MoveStaticMembersProcessor(
//					findMember(icu), 
//					JavaPreferencesSettings.getCodeGenerationSettings(getProject()));
//		processor.setDestinationTypeFullyQualifiedName("p.A");
//		MoveRefactoring refactoring = new MoveRefactoring(processor);
//		
//		return refactoring;
	}

	private IMember[] findMember(ICompilationUnit icu) throws JavaModelException {
		IType targetType = findTargetType(icu);
		for (IMethod method : targetType.getMethods()) {
			if (method.getElementName().equals(TARGET_METHOD_NAME)) {
				return new IMember[] {method};
			}
		}
		throw new RuntimeException("Method " + TARGET_METHOD_NAME + " not found");
	}

	private IType findTargetType(ICompilationUnit icu) throws JavaModelException {
		for (IType type : icu.getTypes()) {
			if (type.getElementName().equals(TARGET_CLASS_NAME)) {
				return type;
			}
			for (IType innerType : type.getTypes()) {
				if (innerType.getElementName().equals(TARGET_CLASS_NAME)) {
					return type;
				}
				for (IMethod method : innerType.getMethods()) {
					try {
						return method.getType(TARGET_CLASS_NAME, 1);
					}
					catch (Exception e) {
						// do nothing, local type does not exist
					}
				}
			}
			for (IMethod method : type.getMethods()) {
				try {
					return method.getType(TARGET_CLASS_NAME, 1);
				}
				catch (Exception e) {
					// do nothing, local type does not exist
				}
			}
		}
		throw new RuntimeException("Class " + TARGET_CLASS_NAME + " not found");
	}

}
