package refactoringtestplugin.pullupfield;

import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.PrimitiveType;

import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;
import edu.uiuc.astgen.classrelationships.RelationshipSpecificationGenerator;
import edu.uiuc.astgen.fieldreferences.DualClassFieldReferenceGenerator;
import org.testorrery.IGenerator;

public class DualClassFieldReference extends PullUpFieldTest {
	
	@Override
	public String getDescription() {
		return "Two classes A and B. A declares a field and B references it in some expression. B extends A. Refactor to push f down to B.";
	}
	
	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/dualclassfieldreference";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() { 
		FieldDeclarationGenerator fieldDeclGen = new FieldDeclarationGenerator(FIELD_TO_REFACTOR);
		fieldDeclGen.setTypeGen(new PrimitiveTypeGenerator(PrimitiveType.INT));
		
		RelationshipSpecificationGenerator relSpecGen = new RelationshipSpecificationGenerator();
		relSpecGen.setInheritance(InheritanceType.SUBCLASS);
		relSpecGen.setEnableReverseInheritance(false);
		relSpecGen.setLocationAll();
		relSpecGen.setEnableReverseLocation(false);
		
		DualClassFieldReferenceGenerator cuGen = new DualClassFieldReferenceGenerator(fieldDeclGen);
		cuGen.setRelationshipSpecificationGen(relSpecGen);
		return cuGen;
	}

}
