package refactoringtestplugin.pullupmethod;

import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.PrimitiveType;

import refactoringtestplugin.pushdownmethod.PushDownMethodTest;
import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.basic.MethodDeclarationGenerator;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.methodrelationships.DualClassMethodChildGenerator;
import org.testorrery.IGenerator;

public class DualClassMethodChild extends PullUpMethodTest {
	protected static final String CLASS_NAME_CHILD = "A";

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/dualclassmethodchild";
	}
	
	@Override
	public String getDescription() {
		return "Two classes A and B. B declares one method and another one that references it in some expression. B extends A. Refactor to pull m up to A.";
	}

	@Override
	protected IGenerator<CompilationUnit> getCUGen() { 
		ModifierGenerator visibilityMethodModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);
		
		ModifierGenerator visibilityFieldModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);		
		
		MethodDeclarationGenerator methDeclGen = new MethodDeclarationGenerator("m"); 
		methDeclGen.setVisibilityModifierGenerator(visibilityMethodModifierGen);
		FieldDeclarationGenerator fieldDecGen = new FieldDeclarationGenerator("theField");
		fieldDecGen.setVisibilityModifierGen(visibilityFieldModifierGen);
		DualClassMethodChildGenerator cuGen = new DualClassMethodChildGenerator(fieldDecGen, methDeclGen, CLASS_NAME_CHILD, CLASS_NAME);
		
		return cuGen;
	}	
}