package refactoringtestplugin.pullupmethod;

import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.Modifier;

import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.basic.MethodDeclarationGenerator;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.methodrelationships.TripleClassMethodChildGenerator;
import org.testorrery.IGenerator;

public class TripleClassMethodChild extends PullUpMethodTest {
	protected static final String CLASS_NAMEA = "A";
	protected static final String CLASS_NAMEC = "C";

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/tripleclassmethodchild";
	}
	
	@Override
	public String getDescription() {
		return "Three classes A, B and C. B declares method m and another one that references it in some expression. B extends C. Refactor to pull m up to A.";
	}

	@Override
	protected IGenerator<CompilationUnit> getCUGen() { 
		ModifierGenerator visibilityMethodModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);
		
		ModifierGenerator visibilityFieldModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);		
		
		MethodDeclarationGenerator methDeclGen = new MethodDeclarationGenerator("m"); 
		methDeclGen.setVisibilityModifierGenerator(visibilityMethodModifierGen);
		FieldDeclarationGenerator fieldDecGen = new FieldDeclarationGenerator("theField");
		fieldDecGen.setVisibilityModifierGen(visibilityFieldModifierGen);
		TripleClassMethodChildGenerator cuGen = new TripleClassMethodChildGenerator(fieldDecGen, methDeclGen, CLASS_NAMEA, CLASS_NAME, CLASS_NAMEC);
		
		return cuGen;
	}	
}