package refactoringtestplugin.pushdownfield;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class Demo extends PushDownFieldTest {
	@Override
	public String getDescription() {
		return "Samples used to test the PushDownField refactoring";
	}
	
	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
			// refactoring completes normally
			String.format("package p; public class A {int %s;}} class B extends A {}", FIELD_TO_REFACTOR),
			// refactoring results in compilation error
			String.format("package p; public class A {int %s;}} class B extends A {int g = %1$s;}", FIELD_TO_REFACTOR),
			// refactoring results in compilation error
			String.format("package p; public class A {int %s;}} class B extends A {void m() {super.%1$s = 0;}}", FIELD_TO_REFACTOR),
		};
			
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
		for (String source : sources) {
			parser.setSource(source.toCharArray());
			parser.setKind(ASTParser.K_COMPILATION_UNIT);
			cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
		}
		return cuGen;	
	}

}
