package refactoringtestplugin.pushdownfield;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.eclipse.jdt.core.dom.Type;
import org.eclipse.jdt.core.dom.TypeDeclaration;

import refactoringtestplugin.commongenerators.FieldReferences;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.basic.MultipleFieldDeclarationGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;
import edu.uiuc.astgen.classrelationships.RelationshipSpecificationGenerator;
import edu.uiuc.astgen.fieldreferences.DualClassFieldReferenceGenerator;
import edu.uiuc.astgen.fieldreferences.FieldReferenceType;
import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class DualClass2FieldsParentDeclaration extends PushDownFieldTest{
	protected static final String FIELD_TO_REFACTOR2 = "g";
	protected static final String CLASS_NAME2 = "B";

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/dualclass2fieldsparentdecl";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		return FieldReferences.dualClass2FieldsParentDeclaration(CLASS_NAME, CLASS_NAME2, FIELD_TO_REFACTOR,FIELD_TO_REFACTOR2);
	}

	@Override
	public String getDescription() {
		return "Two classes A and B. 2 optionally initialized fields. A always includes the declaration of the first field.";
	}

}
