package refactoringtestplugin.pushdownfield;

import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IMember;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.internal.corext.refactoring.structure.PushDownRefactoring;
import org.eclipse.jdt.internal.corext.refactoring.structure.PushDownRefactoringProcessor;
import org.eclipse.ltk.core.refactoring.Refactoring;

import org.testorrery.IGenerator;
import refactoringtestplugin.RefactoringTest;

public abstract class PushDownFieldTest extends RefactoringTest {

	protected static final String FIELD_TO_REFACTOR = "f";
	protected static final String CLASS_NAME = "A";
	
	@Override
	protected String getLogDirPath() {
		return super.getSystemTempDir() + "/pushdownfield";
	}

	@Override
	protected Refactoring getRefactoring(ICompilationUnit icu) throws JavaModelException {
		PushDownRefactoringProcessor processor = new PushDownRefactoringProcessor(findMembers(icu));
		PushDownRefactoring refactoring  = new PushDownRefactoring(processor);
		return refactoring;
	}

	private IMember[] findMembers(ICompilationUnit icu) throws JavaModelException {
		for (IType type : icu.getTypes()) {
			for (IField field : type.getFields()) {
				if (field.getElementName().equals(FIELD_TO_REFACTOR)) {
					return new IMember[] {field};
				}
			}
		}
		throw new RuntimeException("Field " + FIELD_TO_REFACTOR + " was not found"); // TODO: better exception
	}

}
