package refactoringtestplugin.pushdownmethod;

import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.PrimitiveType;

import refactoringtestplugin.pullupmethod.PullUpMethodTest;

import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.basic.MethodDeclarationGenerator;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;
import edu.uiuc.astgen.classrelationships.RelationshipSpecificationGenerator;
import edu.uiuc.astgen.fieldreferences.DualClassFieldReferenceGenerator;
import edu.uiuc.astgen.methodrelationships.DualClassMethodParentGenerator;
import org.testorrery.IGenerator;

public class DualClassMethodParent extends PushDownMethodTest {
	protected static final String CLASS_NAME_CHILD = "B";
	
	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/dualclassmethodparent";
	}
	
	@Override
	public String getDescription() {
		return "Two classes A and B. A declares a method and B references it in some expression. B extends A. Refactor to push m down to B.";
	}

	@Override
	protected IGenerator<CompilationUnit> getCUGen() { 
		ModifierGenerator visibilityMethodModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);
		
		ModifierGenerator visibilityFieldModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);		
				
		MethodDeclarationGenerator methDeclGen = new MethodDeclarationGenerator("m"); 
		methDeclGen.setVisibilityModifierGenerator(visibilityMethodModifierGen);
		FieldDeclarationGenerator fieldDecGen = new FieldDeclarationGenerator("theField");
		fieldDecGen.setVisibilityModifierGen(visibilityFieldModifierGen);
		DualClassMethodParentGenerator cuGen = new DualClassMethodParentGenerator(fieldDecGen, methDeclGen, CLASS_NAME, CLASS_NAME_CHILD);
		
		return cuGen;
	}	
}
