package refactoringtestplugin.removeparameter;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class Demo extends RemoveParameterTest {

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo";
	}
	
	@Override
	public String getDescription() {
		return "Demo";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
				// refactoring completes normally
				String.format("public class A {void %s(int %s){}}", TARGET_METHOD_NAME, TARGET_PARAMETER_NAME),
				// refactoring inapplicable. parameter is used.
				String.format("public class A {int %s(int %s){return %2$s;}}", TARGET_METHOD_NAME, TARGET_PARAMETER_NAME),
				
			};
				
			ASTParser parser = ASTParser.newParser(AST.JLS3);
			Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
			for (String source : sources) {
				parser.setSource(source.toCharArray());
				parser.setKind(ASTParser.K_COMPILATION_UNIT);
				cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
			}
			return cuGen;	
	}


}
