package refactoringtestplugin.renamemethod;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.Chain;
import org.testorrery.IGenerator;

public class Demo extends RenameMethodTest {

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo";
	}
	
	@Override
	public String getDescription() {
		return "Some examples of the rename refactoring";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
			// refactoring completes normally
			String.format("package p; public class A {void %s() {}}", METHOD_TO_RENAME),
		};
			
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
		for (String source : sources) {
			parser.setSource(source.toCharArray());
			parser.setKind(ASTParser.K_COMPILATION_UNIT);
			cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
		}
		return cuGen;	
	}



}
