package refactoringtestplugin.renametype;

import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import org.testorrery.IGenerator;
import org.testorrery.Chain;

public class Demo extends RenameTypeTest {

	@Override
	protected String getLogDirPath() {
		return super.getLogDirPath() + "/demo";
	}
	
	@Override
	protected IGenerator<CompilationUnit> getCUGen() {
		String[] sources = new String[] {
			// refactoring completes normally
			String.format("package p; public class %s {}}", ORIGINAL_TYPE_NAME),		
			// renamed type referenced in another class
			String.format("package p; public class %1$s {} class %2$s {%1$s a}", ORIGINAL_TYPE_NAME, REFERENCING_TYPE_NAME)
		};
			
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		Chain<CompilationUnit> cuGen = new Chain<CompilationUnit>();
		for (String source : sources) {
			parser.setSource(source.toCharArray());
			parser.setKind(ASTParser.K_COMPILATION_UNIT);
			cuGen.add((CompilationUnit)parser.createAST(new NullProgressMonitor()));
		}
		return cuGen;	
	}

}
