package refactoringtestplugin.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileFilter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Plugin;

import sun.reflect.generics.factory.CoreReflectionFactory;

import junit.framework.TestCase;

public class TestASTComparator extends TestCase {

	 FileFilter fileFilter = new FileFilter() {
        public boolean accept(File file) {
            return (file.getName().indexOf(".java") == (file.getName().length() - 5));
        }
	};		
	
	// public void testShowsHowToInstantiate() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public void m1(){" + "}" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// assertTrue("comp units are not equal", comparator.compareIsomorphic());
	// }
	//
	// public void testMethodsAreInDifferentOrder() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public void m1(){" + "}" + "public void m2(){" + "}" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "public void m2(){" + "}" + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// assertTrue("comp units are not equal", comparator.compareIsomorphic());
	// }
	//
	// public void testMethodsAreInDifferentOrder2() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public void m1(){" + "}"
	// + "private char m2(){\n return 'c';" + "}" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "private char m2(){\n return 'c';" + "}"
	// + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// boolean resultComparison = comparator.compareIsomorphic();
	// String compareMessage = comparator.getCompareMessage();
	// assertEquals("", compareMessage);
	// assertTrue("comp units are not equal", resultComparison);
	// }
	//
	// public void testMethodsAreFormattedDifferently() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public void m1(){\n" + "\n\t}"
	// + "private char m2(){return 'c';" + "}" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "private char m2(){\n return 'c';\n" + "}"
	// + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// boolean resultComparison = comparator.compareIsomorphic();
	// String compareMessage = comparator.getCompareMessage();
	// assertEquals("", compareMessage);
	// assertTrue("comp units are not equal", resultComparison);
	// }
	//
	// public void testMethodsHaveDifferentWhiteSpaces() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public void m1(){\n" + "\n\t}"
	// + "private char m2( ){char car = 'c';return car ; " + "}"
	// + "}";
	//
	// String compilationUnitASecond = "package p ;"
	// + "public class A { \n \n\n"
	// + "private char m2(){\n char car='c'; \n return car;\n"
	// + "}" + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// boolean resultComparison = comparator.compareIsomorphic();
	// String compareMessage = comparator.getCompareMessage();
	// assertEquals("", compareMessage);
	// assertTrue("comp units are not equal", resultComparison);
	// }
	//
	// public void testDifferentNumberOfMethod() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "private char m2(){\n return 'c';" + "}" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "private char m2(){\n return 'c';" + "}"
	// + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// boolean resultComparison = comparator.compareIsomorphic();
	// assertFalse("comp units are not equal", resultComparison);
	// }
	//
	// public void testMethodBodiesAreDifferent() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public void m1(){" + "}"
	// + "private char m2(){\n return 'a';" + "}" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "private char m2(){\n return 'c';" + "}"
	// + "public void m1(){" + "}" + "}";
	//
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// boolean resultComparison = comparator.compareIsomorphic();
	// assertFalse("comp units should not be equal", resultComparison);
	// }
	//
	// public void testFieldsAreInDifferentOrder() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public int f1;" + "public int f2;" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "public int f2;" + "public int f1;" + "}";
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// assertTrue("comp units should be equal", comparator.compareIsomorphic());
	// }
	//
	// public void testFieldsAreInDifferentOrderButSomePrivate() throws
	// Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public int f1;\n" + "private int f2;\n" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "private int f2;\n" + "public int f1;\n" + "}";
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// boolean resultComparison = comparator.compareIsomorphic();
	// String compareMessage = comparator.getCompareMessage();
	// assertEquals("", compareMessage);
	// assertTrue("comp units are not equal", resultComparison);
	// }
	//
	// public void testFieldsAreNotEqual() throws Exception {
	// String compilationUnitA = "package p;" + "public class A{"
	// + "public int f1;" + "public char f2;" + "}";
	//
	// String compilationUnitASecond = "package p;" + "public class A{"
	// + "public char f2Ren;" + "public int f1;" + "}";
	// ASTComparator comparator = new ASTComparator();
	// comparator.setUpProject();
	// comparator.setInputs("A.java", compilationUnitA, "A.java",
	// compilationUnitASecond);
	// assertFalse("comp units are not equal", comparator.compareIsomorphic());
	// }
	//
	// public void testCompareFromFiles() throws Exception {
	// // File fileA = new
	// //
	// File("C:\\Workspaces\\TRE\\atre.refactoringRunning\\resources\\testingTheASTComparator\\ASTComparator.java");
	// // File fileASecond = new
	// //
	// File("C:\\Workspaces\\TRE\\atre.refactoringRunning\\resources\\testingTheASTComparator_File2\\ASTComparator.java");
	// // //
	// // ASTComparator comparator = new ASTComparator();
	// // comparator.setUpProject();
	// // comparator.setInputs(fileA, fileASecond);
	// // assertTrue(comparator.compareIsomorphic());
	//
	// // Plugin plugin = Activator.getDefault();
	// //
	// // IPath path = new
	// //
	// Path("atre.refactoringRunning/resources").append("/testingTheASTComparator/ASTComparator.java");
	// // URL url2 = plugin.getBundle().getEntry("/");
	// // URL url = new URL(url2, path.toString());
	// // File fileA = path.toFile();
	// // String OSstring = path.toOSString();
	// // IFile fileForLocation =
	// // ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(path);
	// // String projectName = fileForLocation.getProject().getName();
	// // ResourcesPlugin.getWorkspace();
	// //
	// // IPath path2 = new
	// //
	// Path("resources").append("/testingTheASTComparator_File2/ASTComparator.java");
	// // File fileASecond = path2.toFile();
	//
	// // ASTComparator comparator = new ASTComparator();
	// // comparator.setUpProject();
	// // comparator.setInputs(fileA, fileASecond);
	// // assertTrue("files should be equal", comparator.compareIsomorphic());
	// }
	//
	// // Kely add these 2 methods
	/**
	 * Utility function that returns the system's temporary directory.
	 */
	public static String getSystemTempDir() {
		String tempdir = System.getProperty("java.io.tmpdir");
		if (tempdir == null) {
			throw new IllegalArgumentException("Temp dir is not specified");
		}
		String separator = System.getProperty("file.separator");
		if (!tempdir.endsWith(separator)) {
			return tempdir + separator;
		}
		return tempdir;
	}

	
	 public void testCompareFromFiles_ForGeneratedInputFiles() throws
	 Exception {
	
	 try {
		    String refactoringName = "move";
		    String subDirectoryName = "MoveInnerToTopLevel";
			BufferedWriter out = new BufferedWriter(new FileWriter(
					getSystemTempDir() + File.separator + refactoringName + "_" + subDirectoryName + "_Differences.txt"));
			 ASTComparator comparator = new ASTComparator();
			 comparator.setUpProject();			 			
			 String directory = getSystemTempDir() + File.separator + refactoringName + File.separator + subDirectoryName;
			File directoryFile = new File(directory);
			if (!directoryFile.exists())
				throw new Exception("The directory " + directory + " does not exist");
			File[] files = directoryFile.listFiles();
			int numTestsComparedEqual = 0;
			int numTestsComparedDifferent = 0;
			int numTestsOnlyRefactoredInEclipse =0;
			int numTestsOnlyRefactoredInNetbeans =0;
			int numDifferencesEclipse_Netbeans = 0;
			int numTestsNotRefactored =0;
			List<String> listOfTestDifferences = new ArrayList<String>();
			int numTestsOnlyECNoCompile =0, numTestsOnlyNBNoCompile = 0, numTestsBothECNB_ECNoCompile = 0, numTestsBothECNB_NBNoCompile = 0;
			int numBothEc_Nb=0;

			System.out.println("files.length: "+ files.length);
			for (int i = 0; i < files.length; i++) {				
				directory = files[i].toString();				
				File inputDirectory = new File(directory + File.separator + "in");				
				File notCompile = new File(directory  + File.separator + "out" + File.separator + "PRE_REFACTOR_NOT_COMPILE");
				
				if (inputDirectory.exists() && !notCompile.exists()) {		
					File outDirectory = new File(directory  + File.separator + "out");
					File outNBDirectory = new File(directory + File.separator + "outNB");
					File refactNotPerfInNB = new File(directory + File.separator + "outNB" + File.separator + "REFACTORING_NOT_PERFORMED");
					File[] outJavaFiles = outDirectory.listFiles(fileFilter); 
					File[] outNBJavaFiles = outNBDirectory.listFiles(fileFilter);
					if ((!outDirectory.exists() || (outDirectory.exists() && outJavaFiles.length == 0)) && (refactNotPerfInNB.exists())){
						// refact was not performed neither in Eclipse nor Netbeans
						System.out.println("Test#: " + files[i] + " was neither refactored in Netbeans nor in Eclipse\n");
						out.write("Test#: " + files[i] + " was neither refactored in Netbeans nor in Eclipse\n");
						numTestsNotRefactored++;
					} else if (!outDirectory.exists() || (outDirectory.exists() && outJavaFiles.length == 0)) {
						numTestsOnlyRefactoredInNetbeans++;						
						File f = new File(directory + File.separator + "outNB" + File.separator + "POST_REFACTOR_NOT_COMPILE");
						if (f.exists()) numTestsOnlyNBNoCompile++;
						else {
							numDifferencesEclipse_Netbeans++;
							System.out.println("Test#: " + files[i] + " was refactored in Netbeans but not in Eclipse\n");
							out.write("Test#: " + files[i] + " was refactored in Netbeans but not in Eclipse\n");							
						}
					} else if (refactNotPerfInNB.exists()){
						// only was refactored in Eclipse						
						numTestsOnlyRefactoredInEclipse++;
						
						File f = new File(directory + File.separator + "out" + File.separator + "POST_REFACTOR_NOT_COMPILE");
						if (f.exists()) numTestsOnlyECNoCompile++;
						else {
							numDifferencesEclipse_Netbeans++;
							System.out.println("Test#: " + files[i] + " was refactored in Eclipse but not in Netbeans\n");
							out.write("Test#: " + files[i] + " was refactored in Eclipse but not in Netbeans\n");							
						}
					} else {
						// refactorings was performed in both		
						numBothEc_Nb++;
						File f1 = new File(directory + File.separator + "out" + File.separator + "POST_REFACTOR_NOT_COMPILE");
						File f2 = new File(directory + File.separator + "outNB" + File.separator + "POST_REFACTOR_NOT_COMPILE");
						if (f1.exists() && f2.exists()){
							numTestsBothECNB_ECNoCompile++; numTestsBothECNB_NBNoCompile++;
						} else if (f1.exists()){
							numTestsBothECNB_ECNoCompile++;
						} else if (f2.exists()) {
							numTestsBothECNB_NBNoCompile++;
						} else {
							boolean status = true;
							String message = "";
							if (outJavaFiles.length != outNBJavaFiles.length){ // different number of classes
								status = false;
								message = "Directory out has " + outJavaFiles.length + " java files and directory outNB has " + outNBJavaFiles.length + " java files";
								out.write("Test#" + i + " " + files[i] + "\n" + message + "\n");
							} else {
								int j =0;
								//System.out.println("outJavaFiles.length: "+ outJavaFiles.length);
								while (j < outJavaFiles.length) { // status && 							
									File fileA = outJavaFiles[j];
									File fileB = null;
									for (int k = 0; k < outNBJavaFiles.length; k++) {
										if (outNBJavaFiles[k].getName().equals(fileA.getName())) {
											fileB = outNBJavaFiles[k];
											break;
										}
									}
									if (fileB == null) { // fileA was not found in outNB
										status = false;
										message = "Class " + fileA.getName() + " was not found in directory outNB";
										out.write("Test#" + i + " " + files[i] + "\n" + message + "\n");
									} else {
										try {								
											comparator.setInputs(fileA, fileB);
										} catch (Exception e) {
											System.out.println("files could not be read, # " + i);
											continue;
										}
										if (!comparator.compareIsomorphic()) {
											status = false;
											out.write("Test#" + i + " " + files[i] + " " + fileA.getName() + " is different \n");
											out.write(comparator.getCompareMessage() + "\n\n");
											System.out.println("Test#" + i + " " + files[i] + " " + fileA.getName() + " is different");
										} 
									}
									j++;
								}
							}
							// at the end affecting the totals
							if (status) {
								numTestsComparedEqual++;
								System.out.println("Test#: " + files[i] + " pass");
							} else {							
								listOfTestDifferences.add(directory);
								numTestsComparedDifferent++;
								numDifferencesEclipse_Netbeans++;								
							}								
						}
					}
					
					
//					File fileA = new File(directory  + File.separator + "out" + File.separator + className);// NewA.java					
//					File fileASecond = new File(directory + File.separator + "outNB" + File.separator + className);// NewA.java					
//					if (fileA.exists() && fileASecond.exists()) { // Kely add this conditional						
//						try {
//							
//							comparator.setInputs(fileA, fileASecond);
//						} catch (Exception e) {
//							System.out.println("files could not be read, # " + i);
//							continue;
//						}
//						if (!comparator.compareIsomorphic()) {
//							out.write("Test#" + i + " " + files[i] + "\n");
//							out.write(comparator.getCompareMessage() + "\n\n");
//							listOfTestDifferences.add("Test#" + i);
//							numTestsComparedDifferent++;
//							numDifferencesEclipse_Netbeans++;
//						} else {
//							numTestsComparedEqual++;
//							System.out.println("Test#: " + files[i] + " pass");
//						}						
//						
//					} else if (fileA.exists()) {
//						System.out.println("Test#: " + files[i] + " was refactored in Eclipse but not in Netbeans");
//						out.write("Test#: " + files[i] + " was refactored in Eclipse but not in Netbeans\n");
//						numTestsOnlyRefactoredInEclipse++;
//						numDifferencesEclipse_Netbeans++;
//					} else if (fileASecond.exists()) {
//						System.out.println("Test#: " + files[i] + " was refactored in Netbeans but not in Eclipse");
//						out.write("Test#: " + files[i] + " was refactored in Netbeans but not in Eclipse\n");
//						numTestsOnlyRefactoredInNetbeans++;
//						numDifferencesEclipse_Netbeans++;
//					} else {
//						System.out.println("Test#: " + files[i] + " was neither refactored in Netbeans nor in Eclipse");
//						out.write("Test#: " + files[i] + " was neither refactored in Netbeans nor in Eclipse\n");
//						numTestsNotRefactored++;
//					}
				}
			}
			System.out.println("# Tests that were not refactored neither by Eclipse nor Netbeans: "+ numTestsNotRefactored);
			out.write("# Tests that were not refactored neither by Eclipse nor Netbeans: "+ numTestsNotRefactored+"\n\n");

			System.out.println("# Tests that were only Refactored in Eclipse are: "+ numTestsOnlyRefactoredInEclipse);
			out.write("# Tests that were only Refactored in Eclipse are: "+ numTestsOnlyRefactoredInEclipse + "\n");
			System.out.println("# Tests that were only Refactored in Eclipse that do not compile: " + numTestsOnlyECNoCompile);
			out.write("# Tests that were only Refactored in Eclipse that do not compile: " + numTestsOnlyECNoCompile + "\n\n");

			System.out.println("# Tests that were only Refactored in Netbeans are: "+ numTestsOnlyRefactoredInNetbeans);
			out.write("# Tests that were only Refactored in Netbeans are: "+ numTestsOnlyRefactoredInNetbeans+ "\n");
			System.out.println("# Tests that were only Refactored in Netbeans that do not compile: "+ numTestsOnlyNBNoCompile);
			out.write("# Tests that were only Refactored in Netbeans that do not compile: "+ numTestsOnlyNBNoCompile + "\n\n");
			
			System.out.println("Summary of tests that were refactored in Eclipse and Netbeans");
			out.write("Summary of tests that were refactored in Eclipse and Netbeans\n");
			System.out.println("# Tests that have equivalent outputs in Eclipse & Netbeans are: " + numTestsComparedEqual);
			out.write("# Tests that have equivalent outputs in Eclipse & Netbeans are: " + numTestsComparedEqual + "\n");
			System.out.println("# Tests that have different outputs in Eclipse & Netbeans are: "+ numTestsComparedDifferent);
			out.write("# Tests that have different outputs in Eclipse & Netbeans are: "+ numTestsComparedDifferent+ "\n");
			System.out.println("# Tests that do not compile in Eclipse: "+ numTestsBothECNB_ECNoCompile);
			out.write("# Tests that do not compile in Eclipse: "+ numTestsBothECNB_ECNoCompile + "\n");
			System.out.println("# Tests that do not compile in NetBeans: "+ numTestsBothECNB_NBNoCompile);
			out.write("# Tests that do not compile in NetBeans: "+ numTestsBothECNB_NBNoCompile + "\n\n");
			
			System.out.println("Total # of differences between Eclipse & Netbeans that compile: "+ numDifferencesEclipse_Netbeans);
			out.write("Total # of differences between Eclipse & Netbeans that compile: "+ numDifferencesEclipse_Netbeans+ "\n\n");
			
			System.out.println("Total # for Ec & NB: "+ numBothEc_Nb);
			out.write("Total # for Ec & NB: "+ numBothEc_Nb+ "\n");
			
			
			if (listOfTestDifferences.size() > 0) {
				System.out.println("There are " + listOfTestDifferences.size() 	+ " tests that gave different results in Eclipse & Netbeans: ");
				for (int i = 0; i < listOfTestDifferences.size(); i++) {
					System.out.println(listOfTestDifferences.get(i));
				}
			}
			out.close();
		} catch (IOException e) {
			System.out.println("Error: " + e);
		}

	}

	// For Eclipse's tests
	public void testCompareFromFiles_ForEclipsesTests() throws Exception {
		ASTComparator comparator = new ASTComparator();
		comparator.setUpProject();
		

		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(	getSystemTempDir() + File.separator	+ "Differences_Eclipse.txt"));
			String directory = "C:\\0_Projects_Demo\\Resources\\Eclipse_Tests\\SefWorkSpace\\SefTests"; //C:\\0_Projects_Demo\\Resources\\Eclipse_Tests
			String packages[] = new String[] {"base_out", "object_out"};//{ "base_out", "object_out" };//"invalid", "static_out" 
			int numTestsComparedEqual = 0;
			int numTestsComparedDifferent = 0;
			int numTestsOnlyRefactoredInEclipse =0;
			int numTestsOnlyRefactoredInNetbeans =0;
			int numDifferencesEclipse_Netbeans = 0;
			int numTestsNotRefactored =0;
			ArrayList listOfTestDifferences = new ArrayList();
			String className = "A.java";

			for (int i = 0; i < packages.length; i++) {
				File directoryFile = new File(directory + File.separator + packages[i]);
				if (!directoryFile.exists()) throw new Exception("The directory " + directory + " does not exist");
				File[] files = directoryFile.listFiles();

				for (int j = 0; j < files.length; j++) {
					if (files[j].getName().indexOf("CVS") < 0) {
//						System.out.println("files[j].getName(): " + files[j].getName());
//						File fileA = new File(directory + File.separator + packages[i] + File.separator + "out" + File.separator + "A.java");// NewA.java
//						System.out.println("file 1: " + fileA.getAbsolutePath());
//						File fileASecond = new File(directory + File.separator 	+ packages[i] + File.separator + "outNB" + File.separator + "A.java");// NewA.java
//						System.out.println("file 2: " + fileASecond.getAbsolutePath());
						
						File fileA = new File(directory + File.separator + packages[i] + File.separator + files[j].getName());// NewA.java
						System.out.println("file 1: " + fileA.getAbsolutePath());
						File fileASecond = new File(directory + File.separator 	+ packages[i] + "NB" + File.separator + files[j].getName());// NewA.java
						System.out.println("file 2: " + fileASecond.getAbsolutePath());
						if (fileA.exists() && fileASecond.exists()) { // Kely add this conditional							
							try {								
								comparator.setInputs(fileA, fileASecond);
							} catch (Exception e) {
								System.out.println("files could not be read, # " + i);
								continue;
							}
							if (!comparator.compareIsomorphic()) {
								out.write("Package: " + packages[i] + " Test: " + files[j].getName() + "\n");
								out.write(comparator.getCompareMessage() + "\n\n");
								listOfTestDifferences.add("Package: " + i + " Test: " + files[j].getName());
								numTestsComparedDifferent++;
								numDifferencesEclipse_Netbeans++;
								// System.out.println("Test# " + i + " " + comparator.getCompareMessage());
							} else {
								numTestsComparedEqual++;
								System.out.println("Package: " + packages[i] + " Test: " + files[j].getName() + " pass");
							}						
							
						} else if (fileA.exists()) {
							System.out.println("Package: " + packages[i] + " Test: " + files[j].getName() + " was refactored in Eclipse but not in Netbeans");
							out.write("Package: " + packages[i] + " Test: " + files[j].getName() + " was refactored in Eclipse but not in Netbeans\n");
							numTestsOnlyRefactoredInEclipse++;
							numDifferencesEclipse_Netbeans++;
						} else if (fileASecond.exists()) {
							System.out.println("Package: " + packages[i] + " Test: " + files[j].getName() + " was refactored in Netbeans but not in Eclipse");
							out.write("Package: " + packages[i] + " Test: " + files[j].getName()+ " was refactored in Netbeans but not in Eclipse\n");
							numTestsOnlyRefactoredInNetbeans++;
							numDifferencesEclipse_Netbeans++;
						} else {
							System.out.println("Package: " + packages[i] + " Test: " + files[j].getName() + " was neither refactored in Netbeans nor in Eclipse");
							out.write("Package: " + packages[i] + " Test: " + files[j].getName() + " was neither refactored in Netbeans nor in Eclipse\n");
							numTestsNotRefactored++;
						}
					}
				}

			}
			System.out.println("# Tests that have equivalent outputs in Eclipse & Netbeans are: " + numTestsComparedEqual);
			out.write("# Tests that have equivalent outputs in Eclipse & Netbeans are: " + numTestsComparedEqual + "\n");
			System.out.println("# Tests that have different outputs in Eclipse & Netbeans are: "+ numTestsComparedDifferent);
			out.write("# Tests that have different outputs in Eclipse & Netbeans are: "+ numTestsComparedDifferent+ "\n");
			System.out.println("# Tests that were only Refactored in Eclipse are: "+ numTestsOnlyRefactoredInEclipse);
			out.write("# Tests that were only Refactored in Eclipse are: "+ numTestsOnlyRefactoredInEclipse + "\n");
			System.out.println("# Tests that were only Refactored in Netbeans are: "+ numTestsOnlyRefactoredInNetbeans);
			out.write("# Tests that were only Refactored in Netbeans are: "+ numTestsOnlyRefactoredInNetbeans+ "\n");
			System.out.println("Total # of differences between Eclipse & Netbeans: "+ numDifferencesEclipse_Netbeans);
			out.write("Total # of differences between Eclipse & Netbeans: "+ numDifferencesEclipse_Netbeans + "\n");
			System.out.println("# Tests that were not refactored neither by Eclipse nor Netbeans: "+ numTestsNotRefactored);
			out.write("# Tests that were not refactored neither by Eclipse nor Netbeans: "+ numTestsNotRefactored+"\n\n");
			
			if (listOfTestDifferences.size() > 0) {
				System.out.println("There are " + listOfTestDifferences.size() 	+ " tests that gave different results in Eclipse & Netbeans: ");
				for (int i = 0; i < listOfTestDifferences.size(); i++) {
					System.out.println(listOfTestDifferences.get(i));
				}
			}
			out.close();
		} catch (IOException e) {
			System.out.println("Error: " + e);
		}

	}

}
