package org.testorrery;

import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

/**
 * Generator that wraps another and converts the wrapped generator's values
 */
public abstract class ConvertingGenerator<FromType, ToType> extends	CompositeGenerator<ToType> {
	private IGenerator<FromType> innerGenerator;
	
	public ConvertingGenerator(IGenerator<FromType> innerGenerator) {
		this.innerGenerator = innerGenerator;
	}	
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(innerGenerator);
	}
	
	@Override
	protected ToType generateCurrent() {
		return convert(innerGenerator.current());
	}
	
	protected abstract ToType convert(FromType original);

}
