package org.testorrery;

/**
 * Represents an object that is expected to be generated at a certain index.
 * Utility class used in {@link GeneratorTester}.
 * @author Brett Daniel
 *
 */
public class ObjectIndexPair {
	private final Object _expectedObject;
	private final long _expectedIndex;
	
	public Object getExpectedObject() {
		return _expectedObject;
	}
	
	public long getExpectedIndex() {
		return _expectedIndex;
	}
	
	public ObjectIndexPair(Object expectedObject, long expectedIndex) {
		if (expectedIndex < 0) {
			throw new IllegalArgumentException("Expected indices must be >= 0");
		}
		_expectedObject = expectedObject;
		_expectedIndex = expectedIndex;
	}
}
