package org.testorrery;

import java.lang.reflect.InvocationTargetException;

import org.testorrery.link.GeneratorLink;

/**
 * Abstract class representing a field accessor used by {@link PrototypeGenerator}.
 */
public abstract class PrototypeFieldAccessor<T> {
	private boolean isCombinatoric;
	private Chain<Object> prototypeValues = new Chain<Object>();
	
	public void setIsCombinatoric() {
		isCombinatoric = true;
	}
	public boolean isCombinatoric() {
		return isCombinatoric;
	}
	public GeneratorLink getGeneratorLink() {
		return new GeneratorLink(prototypeValues);
	}
	
	public void addPrototype(T proto) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		prototypeValues.add(getValue(proto));
	}
	public void fillCurrentValue(T toReturn) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setValue(toReturn, prototypeValues.current());			
	}
	
	protected abstract Object getValue(T instance) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
	public abstract void setValue(T instance, Object value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
}