package org.testorrery.examples;

import org.testorrery.Generator;

/**
 * Generates all integers between a given minimum (inclusive) and maximum (inclusive)
 */
public class IntegerRangeGenerator extends Generator<Integer> {
	private int minValue;
	private int maxValue;
	private int cur;
	private int step;
	
	public IntegerRangeGenerator(int minValue, int maxValue) {
		this(minValue, maxValue, 1);
	}
	
	public IntegerRangeGenerator(int minValue, int maxValue, int step) {
		this.minValue = minValue;
		this.maxValue = maxValue;
		this.cur = minValue;
		this.step = step;
	}
	
	@Override
	protected Integer generateNext() {
		int tmp = cur;
		cur += step;
		return tmp;
	}

	@Override
	public void reset() {
		super.reset();
		cur = minValue;		
	}

	@Override
	public boolean hasNext() {
		return cur <= maxValue;
	}

}
