package org.testorrery.examples;

import org.testorrery.CompositeGenerator;
import org.testorrery.IGenerator;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

public class PairGenerator<LeftValueType, RightValueType> extends CompositeGenerator<Pair<LeftValueType, RightValueType>> {
	private IGenerator<LeftValueType> left;
	private IGenerator<RightValueType> right;
	
	public PairGenerator(IGenerator<LeftValueType> leftGenerator, IGenerator<RightValueType> rightGenerator) {
		super();
		left = leftGenerator;
		right = rightGenerator;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return LinkCreator.createCombinatoricLink(left, right);
	}
	
	@Override
	protected Pair<LeftValueType, RightValueType> generateCurrent() {
		return new Pair<LeftValueType, RightValueType>(left.current(), right.current());		
	}
}
