package org.testorrery.examples;

public class Tree<ValueType> {
	public int sizeOfTree;
	public ValueType value;
	public Tree<ValueType> left;
	public Tree<ValueType> right;

	public Tree(ValueType value) {
		this.value = value; 
	}
	
	public Tree(ValueType value, Tree<ValueType> left, Tree<ValueType> right) {
		this.value = value;
		this.left = left;
		this.right = right;
		this.sizeOfTree = (left == null ? 0 : left.sizeOfTree) + (right == null ? 0 : right.sizeOfTree) + 1;
	}
	
	public String toString() {
		return toString(0) + "\n";
	}
	
	protected String toString(int spaces) {
		java.lang.StringBuilder indent = new java.lang.StringBuilder();
		while (spaces-- > 0) {
			indent.append(" ");
		}
		java.lang.StringBuilder sb = new java.lang.StringBuilder();		
		sb.append(indent).append("{ value = \"").append(value).append("\"\n");
		sb.append(indent).append("  size = \"").append(sizeOfTree).append("\"\n");		
		sb.append(indent).append("  left  = ");
		if (left == null) {
			sb.append("<NULL>");
		}
		else {
			sb.append("\n").append(left.toString(indent.length() + 3));
		}
		sb.append("\n");
		sb.append(indent).append("  right = ");
		if (right == null) {
			sb.append("<NULL>");
		}
		else {
			sb.append("\n").append(right.toString(indent.length() + 3));
		}
		sb.append("\n").append(indent).append("}");
		return sb.toString();
	}
	
	
}
