package org.testorrery.link;

import org.testorrery.IGenerator;

/**
 * "Leaf" of an iteration link tree. Advances a child generator when iterated.
 */
public class GeneratorLink implements IIterationLink {
	
	private IGenerator innerGenerator;
	
	public GeneratorLink(IGenerator innerGenerator) {
		this.innerGenerator = innerGenerator;
	}
	
	public IGenerator getInnerGenerator() {
		return innerGenerator;
	}

	public boolean hasNext() {		
		return innerGenerator.hasNext();
	}

	public void next() {
		innerGenerator.next();
	}

	public void reset() {
		innerGenerator.reset();
	}	
	
	public void accept(IIteratorVisitor visitor) {
		visitor.visit(this);
	}
	
}
