package org.testorrery.link;


/**
 * Interface for a node in a generator iteration tree
 */
public interface IIterationLink {
	
	/**
	 * @return true if this node can be iterated
	 */
	boolean hasNext();
	
	/**
	 * Iterates this node (and probably children nodes)
	 *
	 */
	void next();
	
	/**
	 * Resets this node (and probably children nodes)
	 *
	 */
	void reset();

	void accept(IIteratorVisitor visitor);
	
}