package org.testorrery.tests;

import static org.hamcrest.core.IsEqual.equalTo;
import static org.junit.Assert.assertThat;

import org.junit.Test;
import org.testorrery.Chain;
import org.testorrery.CopyableGenerator;
import org.testorrery.ICopyableGenerator;
import org.testorrery.IGenerator;

public class CopyableGeneratorTest {

	@Test
	public void testCopy() {
		ICopyableGenerator<Integer> original = new CopyableGenerator<Integer>() {
			protected IGenerator<Integer> getNewCopy() {
				return new Chain<Integer>(1, 2);
			}
		};
		ICopyableGenerator<Integer> copy = original.copy();		
		
		assertThat(1, equalTo(original.next()));
		assertThat(1, equalTo(copy.next()));

		assertThat(2, equalTo(original.next()));
		assertThat(1, equalTo(copy.current()));
		
		assertThat(2, equalTo(original.current()));
		assertThat(2, equalTo(copy.next()));
		
		original.reset();
		copy.reset();
		
		assertThat(1, equalTo(original.next()));
		assertThat(1, equalTo(copy.next()));

	}
}
