package org.testorrery.tests;

import org.junit.Test;
import org.testorrery.FilteredCompositeGenerator;
import org.testorrery.GeneratorTester;
import org.testorrery.examples.IntegerRangeGenerator;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

public class FilteredCompositeGeneratorTest {

	@Test
	public void testBasic() {
		FilteredCompositeGenerator<Integer> filteredGen = new FilteredCompositeGenerator<Integer>() {
			IntegerRangeGenerator innerGen = new IntegerRangeGenerator(0,5);
			
			@Override
			protected IIterationLink getInitializedIterator() {
				return new GeneratorLink(innerGen);
			}
			
			@Override
			protected boolean iterationIsValid() {
				return innerGen.current() % 2 == 0;
			}
			
			@Override
			protected Integer generateCurrent() {
				return innerGen.current();
			}
		};
		
		GeneratorTester.testExpectedStrings(filteredGen, "0", "2", "4");		
	}
}
