package org.testorrery.tests;

import org.junit.Assert;
import org.junit.Test;
import org.testorrery.IGenerator;
import org.testorrery.IRecursive;
import org.testorrery.Literal;
import org.testorrery.Recurse;

public class RecurseTest {

	boolean hasRecursed = false;
	@Test
	public void basicFunctionality() {
		
		final String testString = "STRING!";
		
		Recurse<String> standin = new Recurse<String>(
				new IRecursive<String>() {					
					public IGenerator<String> recurse() {
						hasRecursed = true;
						return new Literal<String>(testString);
					}
				});
		Assert.assertFalse(hasRecursed);
		Assert.assertTrue(standin.isReset());
		Assert.assertTrue(standin.hasNext());
		Assert.assertEquals(testString, standin.next());	
		Assert.assertFalse(standin.isReset());
		Assert.assertTrue(hasRecursed);
		
		standin.reset();
		Assert.assertEquals(testString, standin.next());			
	}
}
