package org.testorrery.tests.examples;

import org.junit.Assert;
import org.junit.Test;
import org.testorrery.Literal;
import org.testorrery.examples.Graph;
import org.testorrery.examples.GraphGenerator;

public class GraphGeneratorTest {

	@SuppressWarnings("unchecked")
	@Test
	public void demo() {
		// generate all graphs with three nodes
		GraphGenerator<String> graphGen = new GraphGenerator<String>(
				new Literal<String>("1"), 
				new Literal<String>("2"), 
				new Literal<String>("3"));
		
		int i = 0;
		for (Graph g : graphGen) {
			Assert.assertEquals("Graph must have three nodes", g.nodeCount(), 3);
			
			// print for demo
			System.out.println("GRAPH #" + ++i);
			System.out.print(g);
		}
		
		Assert.assertEquals("Wrong number of graphs generated", 512, i);	
	}

}
