package org.testorrery.tests.examples;


import org.junit.Assert;
import org.junit.Test;
import org.testorrery.Chain;
import org.testorrery.Choose;
import org.testorrery.CopyableGenerator;
import org.testorrery.ICopyableGenerator;
import org.testorrery.IGenerator;
import org.testorrery.examples.List;
import org.testorrery.examples.ListGenerator;


public class ListGeneratorTest {
	
	@Test
	public void exhaustiveListDemo() {

		ICopyableGenerator<Integer> valueGen = 
			new CopyableGenerator<Integer>() {
				public IGenerator<Integer> getNewCopy() {
					return new Chain<Integer>(0, 1, 2);
				}
			};
						
		ListGenerator<Integer> listGen = new ListGenerator<Integer>(valueGen,4);
		
		// display results		
		int count = 0;
		for (List list : listGen) {
			System.out.println(list.toString());
			count++;
		}
		// all combinations up to length 4
		Assert.assertEquals(3 + 3 * 3 + 3 * 3 * 3 + 3 * 3 * 3 * 3, count);
	}
	
	@Test
	public void arbitraryListDemo() {
		ICopyableGenerator<Integer> valueGen = 
			new CopyableGenerator<Integer>() {
				public IGenerator<Integer> getNewCopy() {
					return new Choose<Integer>(0, 1, 2);
				}
			};
						
		ListGenerator<Integer> listGen = new ListGenerator<Integer>(valueGen, 10);
		
		// display results
		int count = 0;
		for (List list : listGen) {
			System.out.println(list.toString());
			count++;
		}
		Assert.assertEquals(10, count);
		
	}

}
