package org.testorrery.tests.examples;

import org.junit.Test;
import org.testorrery.Chain;
import org.testorrery.GeneratorTester;
import org.testorrery.Literal;
import org.testorrery.examples.PairGenerator;


public class PairGeneratorTest {

	@Test
	public void basicDemo() {
		Chain<Integer> leftGen = new Chain<Integer>();
		leftGen.add(new Literal<Integer>(1));
		leftGen.add(new Literal<Integer>(2));
		leftGen.add(new Literal<Integer>(3));
		
		Chain<String> rightGen = new Chain<String>();
		rightGen.add(new Literal<String>("S1"));
		rightGen.add(new Literal<String>("S2"));
		rightGen.add(new Literal<String>("S3"));
		rightGen.add(new Literal<String>("S4"));		
		
		PairGenerator<Integer, String> pairGen = 
			new PairGenerator<Integer, String>(leftGen, rightGen);
		
		GeneratorTester.testExpectedStrings(pairGen, 
				"[1,S1]",
				"[1,S2]",
				"[1,S3]",
				"[1,S4]",
				"[2,S1]",
				"[2,S2]",
				"[2,S3]",
				"[2,S4]",
				"[3,S1]",
				"[3,S2]",
				"[3,S3]",
				"[3,S4]");			
	}
	
}
