package org.testorrery.tests.examples;

import org.junit.Assert;
import org.junit.Test;
import org.testorrery.Choose;
import org.testorrery.CopyableGenerator;
import org.testorrery.IGenerator;
import org.testorrery.examples.Tree;
import org.testorrery.examples.TreeGenerator;

public class TreeGeneratorTest {

	@Test
	public void basicDemo() {
		CopyableGenerator<Integer> valueGen = 
			new CopyableGenerator<Integer>() {
				public IGenerator<Integer> getNewCopy() {
					return new Choose<Integer>(new Integer[] {1, 2, 3, 4, 5});
				}
			};
			
		// Create tree generator
		// Produces all trees of size 4 containing a random value between 1 and 5
		TreeGenerator<Integer> treeGen = 
			new TreeGenerator<Integer>(valueGen, 4);
		
		int count = 0;
		for (Tree tree : treeGen) {
			System.out.println("Tree #" + ++count);
			System.out.println(tree.toString());
		}
		
		Assert.assertEquals("Wrong number of trees found", 676, count);
	}
}
