package org.testorrery.tests.link;

import org.junit.Assert;
import org.junit.Test;
import org.testorrery.Chain;
import org.testorrery.link.BinaryLink;
import org.testorrery.link.ExpressionVisitor;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.IIteratorVisitor;
import org.testorrery.link.LinkCreator;

public class ExpressionVisitorTest {

	@Test()
	public void getExpression() {
		final String expression = "(($0 * $1) + ($2 * $3))";
		Chain<Integer> gen = new Chain<Integer>(1);		
		IIterationLink link = LinkCreator.createLinkFromExpression(expression, gen, gen, gen, gen);
		
		String createdExpression = new ExpressionVisitor().getExpression(link);
		
		System.out.println(createdExpression);
		Assert.assertEquals(expression, createdExpression);		
	}
	
	@Test()
	public void unknownBinaryLink() {
		Chain<Integer> gen = new Chain<Integer>(1);				
		IIterationLink link = new BinaryLink(new GeneratorLink(gen), new GeneratorLink(gen)) {
			public void accept(IIteratorVisitor visitor) {
				visitor.visit(this);
			}			
			@Override
			public boolean hasNext() {
				return false;
			}
			@Override
			public void next() {
				// do nothing
			}
			@Override
			public BinaryLink createNewInstance(IIterationLink left, IIterationLink right) {				
				return null;
			}
		};
		
		String createdExpression =  new ExpressionVisitor().getExpression(link);
		
		System.out.println(createdExpression);
		Assert.assertEquals("($0 ? $1)", createdExpression);		
	}
}
