package org.testorrery.tests.link;

import org.junit.Test;
import org.testorrery.Chain;
import org.testorrery.IGenerator;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.SequentialLink;


public class SequentialLinkTest {
	
	@Test()
	public void testIteration() {
		IGenerator<String> gen1 = new Chain<String>("string1", "string2", "string3");
		IGenerator<Integer> gen2 = new Chain<Integer>(1, 2, 3, 4);
		
		SequentialLink link = new SequentialLink(new GeneratorLink(gen1), new GeneratorLink(gen2));
		
		LinkTestUtil.iterateLink(link, 4, gen1, gen2);
	}
	
	@Test()
	public void testNestedIteration() {
		IGenerator<String> gen1 = new Chain<String>("string1", "string2");
		IGenerator<Integer> gen2 = new Chain<Integer>(1, 2, 3);
		IGenerator<Character> gen3 = new Chain<Character>('a', 'b', 'c', 'd');
		
		SequentialLink link = 
			new SequentialLink(
					new GeneratorLink(gen1), 
					new SequentialLink(
							new GeneratorLink(gen2),
							new GeneratorLink(gen3)));
		
		LinkTestUtil.iterateLink(link, 4, gen1, gen2, gen3);
	}
}
