package edu.uiuc.astgen;

import org.testorrery.Chain;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

public class ASTNodeChain<ASTNodeType extends org.eclipse.jdt.core.dom.ASTNode>
		extends ASTNodeGeneratorBase<ASTNodeType> {

	private Chain<ASTNodeType> innerSequence;
	
	public ASTNodeChain() {
		super();
		innerSequence = new Chain<ASTNodeType>();
	}
	
	public ASTNodeChain(ASTNodeType... values) {
		this();
		for (ASTNodeType value : values) {
			add(value);
		}
	}
	
	public ASTNodeChain(ASTNodeGeneratorBase<ASTNodeType>... generators) {
		this();
		for (ASTNodeGeneratorBase<ASTNodeType> gen : generators) {
			add(gen);
		}
	}
	
	public <GeneratorType extends ASTNodeGeneratorBase<ASTNodeType>> void add(GeneratorType generator) {
		innerSequence.add(generator);
	}
	
	public void add(ASTNodeType node) {
		innerSequence.add(node);
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(innerSequence);
	}
	
	@Override
	protected ASTNodeType generateCurrent() {
		return innerSequence.current();
	}
	
	
}
