package edu.uiuc.astgen;

import org.eclipse.jdt.core.dom.ASTNode;
import org.testorrery.Literal;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

public class ASTNodeLiteral<NodeType extends ASTNode>
		extends ASTNodeGeneratorBase<NodeType> {

	private Literal<NodeType> _innerLiteral;
	
	public ASTNodeLiteral(NodeType value) {
		super();
		_innerLiteral = new Literal<NodeType>(value);
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(_innerLiteral);
	}
	
	@Override
	protected NodeType generateCurrent() {
		return _innerLiteral.current();
	}

}
