package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.BooleanLiteral;
import org.testorrery.Chain;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class BooleanLiteralGenerator extends ASTNodeGeneratorBase<BooleanLiteral>{
	public static boolean[] values = {true, false};
	
	private Chain<BooleanLiteral> booleanGenerator;
	
	public BooleanLiteralGenerator() {
		super();
		booleanGenerator = new Chain<BooleanLiteral>();		
		for (int i = 0; i < values.length; i++) {
			booleanGenerator.add(super.getAST().newBooleanLiteral(values[i]));
		}
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(booleanGenerator);
	}
	
	@Override
	protected BooleanLiteral generateCurrent() {
		return booleanGenerator.current();
	}
}
