package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Block;
import org.eclipse.jdt.core.dom.DoStatement;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class DoStatementGenerator extends ASTNodeGeneratorBase<DoStatement>{
	private ASTNodeGeneratorBase<? extends Expression> expressionDeclaration;
	private ASTNodeGeneratorBase<? extends Block> blockDeclaration;
	
	public DoStatementGenerator(
			ASTNodeGeneratorBase<? extends Expression> expressionGen, 
			ASTNodeGeneratorBase<? extends Block> blockGen) {
		expressionDeclaration = expressionGen;
		blockDeclaration = blockGen;
	}
	
	@Override
	protected DoStatement generateCurrent() {
		DoStatement doStatement = super.getAST().newDoStatement();
		doStatement.setExpression(expressionDeclaration.current());
		doStatement.setBody(blockDeclaration.current());
		return doStatement;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return LinkCreator.createCombinatoricLink(
				expressionDeclaration, 
				blockDeclaration);
	}
	
	public static DoStatementGenerator getNewDefaultDoStatementGenerator(){
		// Setting statement 1
		PrimitiveTypeGenerator primitiveTypeGen3 = new PrimitiveTypeGenerator(PrimitiveType.BYTE, PrimitiveType.BOOLEAN);//		
		SimpleNameGenerator nameGen3 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen3 = new SingleVariableDeclarationGenerator(nameGen3, primitiveTypeGen3);
		AssignmentExpressionForVariableGenerator statementGen =new AssignmentExpressionForVariableGenerator(variableGen3);
		
		BlockGenerator blockGen = new BlockGenerator();
		blockGen.addStatementGenerator(statementGen);
		SimpleNameGenerator nameGen1 = new SimpleNameGenerator("b");
		DoStatementGenerator doStatement = new DoStatementGenerator(nameGen1, blockGen);
		return doStatement;
	}

}
