package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ExpressionStatement;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

/**
 * Converts an expression generator into a statement generator
 */
public class ExpressionStatementGenerator extends
		ASTNodeGeneratorBase<ExpressionStatement> {

	private ASTNodeGeneratorBase<? extends Expression> expressionGen;
	
	public ExpressionStatementGenerator(ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		this.expressionGen = expressionGen;
	}
	
	public ASTNodeGeneratorBase<? extends Expression> getExpressionGen() {
		return expressionGen;
	}
	public void setExpressionGen(ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		this.expressionGen = expressionGen;
	}

	@Override
	protected ExpressionStatement generateCurrent() {
		return super.getAST().newExpressionStatement(expressionGen.current());
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(expressionGen);
	}

}
