package edu.uiuc.astgen.basic;

import java.util.Random;

import org.eclipse.jdt.core.dom.NumberLiteral;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.testorrery.Chain;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class NumberLiteralGenerator extends ASTNodeGeneratorBase<NumberLiteral> {
    String[] listValues;
    private int numValues;
    private PrimitiveType.Code type;
    private Random r;
    
    private Chain<NumberLiteral> numberLiteralGenerator;
    
	public NumberLiteralGenerator(int numValues, PrimitiveType.Code type) {
		super();
		numberLiteralGenerator = new Chain<NumberLiteral>();
    	r = new Random();
    	listValues = new String[numValues];
    	int i=0;
    	while (i < numValues) {
    		if (type.equals(PrimitiveType.BYTE)) {
    			byte value = (byte)(r.nextDouble()*128);
    			int sign = r.nextInt(2);
        		if (sign == 0 && value <=127) {
        			listValues[i++]=String.valueOf(value);
        			numberLiteralGenerator.add(super.getAST().newNumberLiteral(String.valueOf(value)));
        		} 	
        		else {
        			listValues[i++]=String.valueOf(value*-1);
        			numberLiteralGenerator.add(super.getAST().newNumberLiteral(String.valueOf(value*-1)));
        		}	
    		}
    	}
    	this.numValues = numValues;
    	this.type = type;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(numberLiteralGenerator);
	}

	@Override
	protected NumberLiteral generateCurrent() {
		return numberLiteralGenerator.current();
	}	
}
