package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Name;
import org.eclipse.jdt.core.dom.PackageDeclaration;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class PackageDeclarationGenerator extends
		ASTNodeGeneratorBase<PackageDeclaration> {

	private ASTNodeGeneratorBase<? extends Name> nameGen;
	
	public PackageDeclarationGenerator(ASTNodeGeneratorBase<? extends Name> nameGen) {
		super();
		this.nameGen = nameGen;
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(nameGen);
	}
	
	@Override
	protected PackageDeclaration generateCurrent() {
		PackageDeclaration pd = super.getAST().newPackageDeclaration();
		pd.setName(nameGen.current());
		
		return pd;
	}
}
