package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ReturnStatement;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class ReturnStatementGenerator extends ASTNodeGeneratorBase<ReturnStatement>{
	private ASTNodeGeneratorBase<? extends Expression> expressionDeclaration;

	public ReturnStatementGenerator() {
		super();
	}
	
	public ReturnStatementGenerator(ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		super();
		expressionDeclaration = expressionGen;
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(expressionDeclaration);
	}
		
	@Override
	protected ReturnStatement generateCurrent() {
		ReturnStatement returnStatement = super.getAST().newReturnStatement();
		returnStatement.setExpression(expressionDeclaration.current());
		return returnStatement;
	}

}
