package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.SimpleName;
import org.testorrery.IGenerator;
import org.testorrery.Literal;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

/**
 * Generates SimpleName nodes
 */
public class SimpleNameGenerator extends ASTNodeGeneratorBase<SimpleName> {

	private IGenerator<String> _nameGenerator;
	
	public SimpleNameGenerator(String name) {
		this(new Literal<String>(name));
	}
	
	public SimpleNameGenerator(IGenerator<String> nameGenerator) {
		super();
		_nameGenerator = nameGenerator;
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {	
		return new GeneratorLink(_nameGenerator);
	}

	@Override
	protected SimpleName generateCurrent() {
		return super.getAST().newSimpleName(_nameGenerator.current());
	}
}
