package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.StringLiteral;
import org.testorrery.Chain;
import org.testorrery.GeneratorTester;
import org.testorrery.IGenerator;
import org.testorrery.link.CombinatoricLink;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class StringLiteralGenerator extends ASTNodeGeneratorBase<StringLiteral>{
	private IGenerator<String> escapedValue;

	public StringLiteralGenerator (IGenerator<String> escapedValueGen) {
		super();
		escapedValue = escapedValueGen;
	}
	
	@Override
	protected StringLiteral generateCurrent() {		
		StringLiteral stringLiteral = super.getAST().newStringLiteral();		
		stringLiteral.setEscapedValue(escapedValue.current());
		return stringLiteral;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator linkCreator = new LinkCreator(new CombinatoricLink());
		linkCreator.add(escapedValue);
		return linkCreator.getLink();
		
	}
	
	public static StringLiteralGenerator getNewDefaultStringLiteralGenerator(){
		Chain<String> chainOfStrings = new Chain<String>();
		chainOfStrings.add("\"name1\"");
		chainOfStrings.add("\"name2\"");
		StringLiteralGenerator stringLiteralGen = new StringLiteralGenerator(chainOfStrings);
		GeneratorTester.testExpectedCount(stringLiteralGen, 2);	
		return stringLiteralGen;
	}

}
