package edu.uiuc.astgen.basic;

import java.util.ArrayList;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.SuperConstructorInvocation;
import org.testorrery.IGenerator;
import org.testorrery.link.CombinatoricLink;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class SuperConstructorInvocationGenerator extends ASTNodeGeneratorBase<SuperConstructorInvocation>{
	private ArrayList<IGenerator<? extends Expression>> arguments;
	
	public SuperConstructorInvocationGenerator() {
		super();
		arguments = new ArrayList<IGenerator<? extends Expression>>();
	}
	
	public void addArgumentGenerator(IGenerator<? extends Expression> argumentGen) {
		arguments.add(argumentGen);
	}	

	@Override
	protected SuperConstructorInvocation generateCurrent() {
		SuperConstructorInvocation superConstructorInvocation = super.getAST().newSuperConstructorInvocation();
		for (IGenerator<? extends Expression> argumentGen : arguments) {
			Expression argument = argumentGen.current();
			if (argument != null) {
				superConstructorInvocation.arguments().add(argument);
			}
		}		
		return superConstructorInvocation;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator linkCreator = new LinkCreator(new CombinatoricLink());
		linkCreator.addAll(arguments);
		return linkCreator.getLink();
	}


}
