package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.eclipse.jdt.core.dom.SwitchCase;
import org.testorrery.link.CombinatoricLink;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class SwitchCaseGenerator extends ASTNodeGeneratorBase<SwitchCase>{
	private ASTNodeGeneratorBase<? extends Expression> expressionDeclaration;
	
	public SwitchCaseGenerator(ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		super();
		expressionDeclaration = expressionGen;
	}	

	@Override
	protected SwitchCase generateCurrent() {
		SwitchCase switchCase  = super.getAST().newSwitchCase();	
		switchCase.setExpression(expressionDeclaration.current());
		return switchCase;		
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator lc = new LinkCreator(new CombinatoricLink());
		lc.add(expressionDeclaration);
		return lc.getLink();
	}

	public static SwitchCaseGenerator getNewDefaultSwitchCaseGenerator() {
		NumberLiteralGenerator numberGen = new NumberLiteralGenerator(2, PrimitiveType.BYTE);
		SwitchCaseGenerator switchCaseGen = new SwitchCaseGenerator(numberGen);	
		return switchCaseGen;
	}
}
