package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ThrowStatement;
import org.testorrery.GeneratorTester;
import org.testorrery.IGenerator;
import org.testorrery.link.CombinatoricLink;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class ThrowStatementGenerator extends ASTNodeGeneratorBase<ThrowStatement>{
	private IGenerator<? extends Expression> expressionDeclaration;
	
	public ThrowStatementGenerator (ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		super();
		expressionDeclaration = expressionGen;
	}

	@Override
	protected ThrowStatement generateCurrent() {
		ThrowStatement throwStatement = super.getAST().newThrowStatement();
		throwStatement.setExpression(expressionDeclaration.current());
		return throwStatement;	
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator linkCreator = new LinkCreator(new CombinatoricLink());
		linkCreator.add(expressionDeclaration);
		return linkCreator.getLink();
	}
	
	public static ThrowStatementGenerator getNewDefaultThrowStatementGenerator(){
		ClassInstanceCreationGenerator classInstanceCreationGen = ClassInstanceCreationGenerator.getNewDefaultClassInstanceCreationGenerator();
		ThrowStatementGenerator throwStatementGen = new ThrowStatementGenerator(classInstanceCreationGen);
		GeneratorTester.testExpectedCount(throwStatementGen, 3);		
		return throwStatementGen;
	}

}
