package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Block;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.WhileStatement;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class WhileStatementGenerator extends ASTNodeGeneratorBase<WhileStatement>{
	private ASTNodeGeneratorBase<? extends Expression> expressionDeclaration;
	private ASTNodeGeneratorBase<? extends Block> blockDeclaration;

	public WhileStatementGenerator(
			ASTNodeGeneratorBase<? extends Expression> expressionGen, 
			ASTNodeGeneratorBase<? extends Block> blockGen) {
		expressionDeclaration = expressionGen;
		blockDeclaration = blockGen;
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return LinkCreator.createCombinatoricLink(
				expressionDeclaration, 
				blockDeclaration);
	}	
	
	@Override
	protected WhileStatement generateCurrent() {
		WhileStatement whileStatement = super.getAST().newWhileStatement();
		whileStatement.setExpression(expressionDeclaration.current());
		whileStatement.setBody(blockDeclaration.current());
		return whileStatement;
	}

}
