package edu.uiuc.astgen.classrelationships;

public enum RelationshipDirection {
	/**
	 * Two classes are not related
	 */
	UNRELATED,
	/**
	 * A references B
	 */
	A_TO_B,
	/**
	 * B references A
	 */
	B_TO_A,
	/**
	 * It is unknown whether two classes are related, and if they are, the relationship direction
	 *  has not been specified.
	 */
	UNSPECIFIED;
	
	public RelationshipDirection getReverse() {
		if (this == B_TO_A) {
			return A_TO_B;
		}
		if (this == A_TO_B) {
			return B_TO_A;
		}
		return this;
	}
}
