package edu.uiuc.astgen.classrelationships;

/**
 * Interface for a type that can be used to define a relationship between two classes.
 */
public interface RelationshipSpecification {
	/**
	 * @return the object that can be used to build a relationship between two classes
	 */
	RelationshipBuilder getBuilder();
	/**
	 * @return the default direction of the relationship
	 */
	RelationshipDirection getDirection();
	/**
	 * @return whether the specification makes sense when reversed
	 */
	Reversibility getReversibility();
	/**
	 * @return a string (usually the toString of an enum) that describes this specification
	 */
	String getDescription();
}
