package edu.uiuc.astgen.methodrelationships;

import org.testorrery.Chain;
import org.testorrery.CompositeGenerator;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

public class MethodReferenceBuilderGenerator extends CompositeGenerator<MethodReferenceBuilder> {

	private Chain<MethodReferenceBuilder> builderChain;
	
	@Override
	protected IIterationLink getInitializedIterator() {
		builderChain = new Chain<MethodReferenceBuilder>();
		builderChain.add(new UnqualifiedBuilder());
		builderChain.add(new NewInstanceBuilder());
		builderChain.add(new ThisBuilder());
		builderChain.add(new QualifiedThisBuilder());
		builderChain.add(new SuperBuilder());
		
		return new GeneratorLink(builderChain);
	}

	@Override
	protected MethodReferenceBuilder generateCurrent() {
		return builderChain.current();
	}

}
