package edu.uiuc.astgen.methodrelationships;

import org.testorrery.Chain;
import org.testorrery.CompositeGenerator;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

public class MethodRelationshipBuilderGenerator extends CompositeGenerator<MethodRelationshipBuilder> {
	
	private Chain<MethodRelationshipBuilder> builderChain;
	
	@Override
	protected IIterationLink getInitializedIterator() {
		builderChain = new Chain<MethodRelationshipBuilder>();
		builderChain.add(new SeparateBuilder());
		builderChain.add(new OverloadAddBuilder());
		builderChain.add(new OverloadRemoveBuilder());
		builderChain.add(new OverrideBuilder());
		
		return LinkCreator.createCombinatoricLink(builderChain);
	}
	
	@Override
	protected MethodRelationshipBuilder generateCurrent() {
		return builderChain.current();
	}

}
