package edu.uiuc.astgen.methodrelationships;

import org.testorrery.Chain;
import org.testorrery.CompositeGenerator;
import org.testorrery.link.GeneratorLink;
import org.testorrery.link.IIterationLink;

public class StatementInBlockBuilderGenerator extends
		CompositeGenerator<StatementInBlockBuilder> {
	
	private Chain<StatementInBlockBuilder> builderChain;
	
	@Override
	protected IIterationLink getInitializedIterator() {
		if (builderChain == null) {
			builderChain = new Chain<StatementInBlockBuilder>(
					new InBlockBuilder(),
					new InSubBlockBuilder(),
					new InLocalClassBuilder());
		}
		return new GeneratorLink(builderChain);		
	}

	@Override
	protected StatementInBlockBuilder generateCurrent() {
		return builderChain.current();
	}

}
