package edu.uiuc.astgen.nestedexpressions;

import org.eclipse.jdt.core.dom.AST;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import org.testorrery.CompositeGenerator;

/**
 * Abstract base class for generators that return a {@link NestedExpressionBuilder}
 */
public abstract class BuilderGenerator extends CompositeGenerator<NestedExpressionBuilder> {

	private OperandType operandType = OperandType.OBJECT;
	
	protected BuilderGenerator(OperandType operandType) {
		this.operandType = operandType;
	}
	
	/** 
	 * Utility method that returns the default AST used for creating Expressions
	 */
	public static AST getDefaultAST() {
		return ASTNodeGeneratorBase.ast();
	}

	protected OperandType getOperandType() {
		return this.operandType;
	}
	
}
