package edu.uiuc.astgen.nestedexpressions;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Name;

/**
 * Trivial {@link NestedExpressionBuilder} that does not do any nesting 
 */
public class NotNestedBuilder extends NestedExpressionBuilder {
	private OperandType operandType;
	public NotNestedBuilder() {
		this.operandType = null;
	}
	public NotNestedBuilder(OperandType operandType) {
		this.operandType = operandType;
	}
	public Expression build(Expression innerExpression, Name dummyVariable) {
		return innerExpression;
	}
	public boolean applicableTo(OperandType operandType) {
		if (operandType == null) {
			return true;
		}
		return this.operandType == operandType;
	}
	@Override
	public OperandType outputType() {
		return operandType;
	}
}