package edu.uiuc.astgen.nestedexpressions;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Name;
import org.eclipse.jdt.core.dom.ParenthesizedExpression;

import edu.uiuc.astgen.ASTNodeGeneratorBase;

public class ParenthesesBuilder extends NestedExpressionBuilder {
	private OperandType operandType;
	public ParenthesesBuilder() {
		this.operandType = null;
	}
	public ParenthesesBuilder(OperandType operandType) {
		this.operandType = operandType;
	}
	public Expression build(Expression innerExpression, Name dummyVariable) {
		AST ast = ASTNodeGeneratorBase.ast();
		ParenthesizedExpression parenExpr = ast.newParenthesizedExpression();
		parenExpr.setExpression(innerExpression);
		return parenExpr;
	}
	public boolean applicableTo(OperandType operandType) {
		if (operandType == null) {
			return true;
		}
		return operandType == this.operandType;
	}
	@Override
	public OperandType outputType() {
		return this.operandType;
	}
}
