package edu.uiuc.astgen.statements;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Statement;
import org.eclipse.jdt.core.dom.VariableDeclarationFragment;
import org.eclipse.jdt.core.dom.VariableDeclarationStatement;

import edu.uiuc.astgen.nestedexpressions.OperandType;

public class DummyAssignmentBuilder extends StatementWithExpressionBuilder {
	public Statement build(Expression innerExpression) {
		VariableDeclarationFragment varDeclFrag = ast.newVariableDeclarationFragment();
		varDeclFrag.setName(ast.newSimpleName("o"));
		varDeclFrag.setInitializer(innerExpression);
		VariableDeclarationStatement varDeclStmt = ast.newVariableDeclarationStatement(varDeclFrag);
		varDeclStmt.setType(ast.newSimpleType(ast.newSimpleName("Object")));
		return varDeclStmt;
	}
	public boolean applicableTo(OperandType operandType) {
		return operandType != OperandType.VOID;
	}
}
