package edu.uiuc.astgen.statements;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.IfStatement;
import org.eclipse.jdt.core.dom.Statement;

import edu.uiuc.astgen.nestedexpressions.OperandType;

public class IfTestBuilder extends StatementWithExpressionBuilder {
	public Statement build(Expression innerExpression) {
		IfStatement ifStmt = ast.newIfStatement();
		ifStmt.setExpression(innerExpression);
		ifStmt.setThenStatement(ast.newBlock());
		return ifStmt;			
	}
	public boolean applicableTo(OperandType operandType) {
		return operandType == OperandType.BOOLEAN;
	}
}
