package edu.uiuc.astgen.statements;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Statement;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.astgen.nestedexpressions.OperandType;

/**
 * Abstract base class for builders that create a Statement containing an Expression 
 */
public abstract class StatementWithExpressionBuilder {
	protected static final AST ast = ASTNodeGeneratorBase.ast();
	
	public abstract Statement build(Expression innerExpression);
	public abstract boolean applicableTo(OperandType operandType);
	
	public static StatementWithExpressionBuilder[] allExpressionTypes() {
		return new StatementWithExpressionBuilder[] {
			new ExpressionStatementBuilder(),
			new DummyAssignmentBuilder(),
			new IfTestBuilder(),
			new WhileTestBuilder(),
			// TODO: more statement types
		};
	}
}





