package edu.uiuc.astgen.statements;

import org.testorrery.Chain;
import org.testorrery.CompositeGenerator;
import org.testorrery.link.IIterationLink;
import org.testorrery.link.LinkCreator;

public class StatementWithExpressionBuilderGenerator extends
		CompositeGenerator<StatementWithExpressionBuilder> {

	private Chain<StatementWithExpressionBuilder> builderGen;

	public StatementWithExpressionBuilderGenerator(StatementWithExpressionBuilder...builders) {
		this.builderGen = new Chain<StatementWithExpressionBuilder>(builders);
	}

	public static StatementWithExpressionBuilderGenerator allExpressionTypes() {
		return new StatementWithExpressionBuilderGenerator(StatementWithExpressionBuilder.allExpressionTypes());
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return LinkCreator.createCombinatoricLink(builderGen);
	}

	@Override
	protected StatementWithExpressionBuilder generateCurrent() {
		return builderGen.current();
	}

}
