package edu.uiuc.astgen.statements;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Statement;
import org.eclipse.jdt.core.dom.WhileStatement;

import edu.uiuc.astgen.nestedexpressions.OperandType;

public class WhileTestBuilder extends StatementWithExpressionBuilder {
	public Statement build(Expression innerExpression) {
		WhileStatement whileStmt = ast.newWhileStatement();
		whileStmt.setExpression(innerExpression);
		whileStmt.setBody(ast.newBlock());
		return whileStmt;
	}
	public boolean applicableTo(OperandType operandType) {
		return operandType == OperandType.BOOLEAN;
	}
}
