package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.ArrayFieldDeclarationGenerator;
import edu.uiuc.astgen.basic.ArrayTypeGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import org.testorrery.Chain;
import org.testorrery.GeneratorTester;

public class ArrayFieldDeclarationGeneratorTest {
	@Test
	public void testBasic() {
		ArrayFieldDeclarationGenerator afdg = new ArrayFieldDeclarationGenerator();
		afdg.setTypeGen(new PrimitiveTypeGenerator(PrimitiveType.INT, PrimitiveType.BOOLEAN));
		afdg.setDimGen(new Chain<Integer>(0, 2));
		afdg.setNameGen(new SimpleNameGenerator(new Chain<String>("f1", "f2")));
		GeneratorTester.testExpectedCount(afdg, 2 * 2 * 2);
	}
	
	@Test
	public void testArrayedType() {		
		ArrayTypeGenerator arrTypGen = new ArrayTypeGenerator();
		arrTypGen.setSubscriptNumberGen(new Chain<Integer>(0, 2));
		arrTypGen.setTypeGen(new PrimitiveTypeGenerator(PrimitiveType.INT, PrimitiveType.BOOLEAN));
		
		ArrayFieldDeclarationGenerator afdg = new ArrayFieldDeclarationGenerator();
		afdg.setTypeGen(arrTypGen);
		afdg.setDimGen(new Chain<Integer>(0, 2));
		
		GeneratorTester.testExpectedCount(afdg, 2 * 2 * 2);
		
	}
}
