package edu.uiuc.astgen.test.basic;

import org.junit.*;
import org.eclipse.jdt.core.dom.*;

import edu.uiuc.astgen.*;
import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.basic.CompilationUnitGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;

import org.testorrery.GeneratorTester;

public class CompilationUnitGeneratorTest {

	@Test() 
	public void testBasicFunctionality() {
		AST ast = ASTNodeGeneratorBase.ast(); 
			
		ClassGenerator type1 =  new ClassGenerator(new SimpleNameGenerator("class1"));
		
		ASTNodeChain<TypeDeclaration> classSeq = new ASTNodeChain<TypeDeclaration>();
		classSeq.add(new ClassGenerator(new SimpleNameGenerator("class2")));
		classSeq.add(new ClassGenerator(new SimpleNameGenerator("class3")));
				
		PackageDeclaration packageDecl = ast.newPackageDeclaration();
		packageDecl.setName(ast.newName("asttest.test"));
		ASTNodeLiteral<PackageDeclaration> packageGen = new ASTNodeLiteral<PackageDeclaration>(packageDecl);
		
		CompilationUnitGenerator cuGen = new CompilationUnitGenerator(packageGen);
		cuGen.addDeclarationGenerator(type1);
		cuGen.addDeclarationGenerator(classSeq);
		
		GeneratorTester.testExpectedCount(cuGen, 2);
		
	}
}
