package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.AssignmentExpressionForVariableGenerator;
import edu.uiuc.astgen.basic.BlockGenerator;
import edu.uiuc.astgen.basic.IfStatementGenerator;
import edu.uiuc.astgen.basic.InfixExpressionGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.basic.DoStatementGenerator;

import org.testorrery.GeneratorTester;

public class DoStatementGeneratorTest {

	@Test()
	public void DefaultDoStatement() throws Exception {
		GeneratorTester.testExpectedCount(DoStatementGenerator.getNewDefaultDoStatementGenerator(), 2);
	}
	
	@Test()
	public void testBasicFunctionality() throws Exception {
		PrimitiveTypeGenerator primitiveTypeGen1 = new PrimitiveTypeGenerator(PrimitiveType.BOOLEAN);//		
		SimpleNameGenerator nameGen1 = new SimpleNameGenerator("b");
				
		// Setting statement 1
		PrimitiveTypeGenerator primitiveTypeGen3 = new PrimitiveTypeGenerator(PrimitiveType.BYTE);//		
		SimpleNameGenerator nameGen3 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen3 = new SingleVariableDeclarationGenerator(nameGen3, primitiveTypeGen3);
		AssignmentExpressionForVariableGenerator statementGen =new AssignmentExpressionForVariableGenerator(variableGen3);
		
		// Setting statement 2
		PrimitiveTypeGenerator primitiveTypeGen = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);//
		
		SimpleNameGenerator nameGen = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen = new SingleVariableDeclarationGenerator(nameGen, primitiveTypeGen);
		
		PrimitiveTypeGenerator primitiveTypeGen2 = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);//
		
		SimpleNameGenerator nameGen2 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen2 = new SingleVariableDeclarationGenerator(nameGen2, primitiveTypeGen2);		

		InfixExpressionGenerator infixGen = new InfixExpressionGenerator(variableGen);
		AssignmentExpressionForVariableGenerator statementGen2 =new AssignmentExpressionForVariableGenerator(variableGen2); 
		
		// Setting the else statement
		PrimitiveTypeGenerator primitiveTypeGen_Else = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);//
		
		SimpleNameGenerator nameGen_Else = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen_Else = new SingleVariableDeclarationGenerator(nameGen_Else, primitiveTypeGen_Else);
		AssignmentExpressionForVariableGenerator statementGen_Else =new AssignmentExpressionForVariableGenerator(variableGen_Else);
		
		//SingleVariableDeclarationGenerator variableGen = new SingleVariableDeclarationGenerator(nameGen, primitiveTypeGen);
		
		IfStatementGenerator ifGen = new IfStatementGenerator(infixGen, statementGen2, statementGen_Else);//4		
		
		// Setting the Block
		BlockGenerator blockGen = new BlockGenerator();
		blockGen.addStatementGenerator(statementGen);
		blockGen.addStatementGenerator(ifGen);
						 
		DoStatementGenerator doGen = new DoStatementGenerator(nameGen1, blockGen);
		GeneratorTester.testExpectedCount(doGen, 8);
	}	
}
