package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.AssignmentExpressionForVariableGenerator;
import edu.uiuc.astgen.basic.ForStatementGenerator;
import edu.uiuc.astgen.basic.IfStatementGenerator;
import edu.uiuc.astgen.basic.InfixExpressionGenerator;
import edu.uiuc.astgen.basic.PostFixExpressionGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.basic.VariableDeclarationExpressionGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;

import org.testorrery.GeneratorTester;

public class ForStatementGeneratorTest {
	@Test()
	public void testBasicFunctionality() throws Exception {
		PrimitiveTypeGenerator primitiveTypeGen1 = new PrimitiveTypeGenerator(PrimitiveType.BYTE);//		
		SimpleNameGenerator nameGen1 = new SimpleNameGenerator("v1");
		VariableDeclarationExpressionGenerator variableGen = new VariableDeclarationExpressionGenerator(nameGen1, primitiveTypeGen1);
		
		PrimitiveTypeGenerator primitiveTypeGen2 = new PrimitiveTypeGenerator(PrimitiveType.BYTE);//		
		SimpleNameGenerator nameGen2 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen2 = new SingleVariableDeclarationGenerator(nameGen2, primitiveTypeGen2);		
		InfixExpressionGenerator infixGen = new InfixExpressionGenerator(variableGen2);
		
		PrimitiveTypeGenerator primitiveTypeGen3 = new PrimitiveTypeGenerator(PrimitiveType.BYTE);//		
		SimpleNameGenerator nameGen3 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen3 = new SingleVariableDeclarationGenerator(nameGen3, primitiveTypeGen3);
		AssignmentExpressionForVariableGenerator statementGen =new AssignmentExpressionForVariableGenerator(variableGen3);

		PrimitiveTypeGenerator primitiveTypeGen4 = new PrimitiveTypeGenerator(PrimitiveType.BYTE);//		
		SimpleNameGenerator nameGen4 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen4 = new SingleVariableDeclarationGenerator(nameGen4, primitiveTypeGen4);
		PostFixExpressionGenerator postfixGen = new PostFixExpressionGenerator(variableGen4);
						 
		ForStatementGenerator forGen = new ForStatementGenerator(infixGen, statementGen);
		forGen.addInitializerExpression(variableGen);
		forGen.addUpdaterExpression(postfixGen);
		//ASTNodeGeneratorTestUtil.testBasicFunctionality(infixGen, 1);
		//ASTNodeGeneratorTestUtil.testBasicFunctionality(postfixGen, 1);
		//ASTNodeGeneratorTestUtil.testBasicFunctionality(statementGen, 1);
		//ASTNodeGeneratorTestUtil.testBasicFunctionality(variableGen, 1);
		GeneratorTester.testExpectedCount(forGen, 2);
	}	
}
