package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.eclipse.jdt.core.dom.SimpleType;
import org.eclipse.jdt.core.dom.Type;
import org.junit.Test;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.ASTNodeLiteral;
import edu.uiuc.astgen.basic.GetterSetterGenerator;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;

import org.testorrery.GeneratorTester;
import org.testorrery.IGenerator;

public class GetterSetterGeneratorTest {
AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
	
	@Test
	public void testBasicFunctionality() {
		ModifierGenerator visibilityModifierGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				(Modifier.ModifierKeyword)null);

		GetterSetterGenerator gettersetterGen = new GetterSetterGenerator("field");
		gettersetterGen.setTypeGen(new ASTNodeChain<Type>(
				ast.newPrimitiveType(PrimitiveType.INT)));	
		gettersetterGen.setVisibilityModifierGen(visibilityModifierGen);
//				,
//				ast.newSimpleType(ast.newSimpleName("String")),
//				ast.newSimpleType(ast.newSimpleName("Integer")),
//				ast.newSimpleType(ast.newSimpleName("Boolean")),
//				ast.newSimpleType(ast.newSimpleName("Object")
		
		
		GeneratorTester.testExpectedCount(
				gettersetterGen,				
				6);
	}
}
