package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.AssignmentExpressionForVariableGenerator;
import edu.uiuc.astgen.basic.IfStatementGenerator;
import edu.uiuc.astgen.basic.InfixExpressionGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;

import org.testorrery.GeneratorTester;

public class IfStatementGeneratorTest {

	@Test()
	public void testBasicFunctionality() throws Exception {
		// Setting the InfixExpression
		PrimitiveTypeGenerator primitiveTypeGen = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);		
		SimpleNameGenerator nameGen = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen = new SingleVariableDeclarationGenerator(nameGen, primitiveTypeGen);
		InfixExpressionGenerator infixGen = new InfixExpressionGenerator(variableGen);
		
		// Setting the AssignmentExpression
		PrimitiveTypeGenerator primitiveTypeGen2 = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);	
		SimpleNameGenerator nameGen2 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen2 = new SingleVariableDeclarationGenerator(nameGen2, primitiveTypeGen2);		
		AssignmentExpressionForVariableGenerator statementGen =new AssignmentExpressionForVariableGenerator(variableGen2);

		// Setting the AssignmentExpression
		PrimitiveTypeGenerator primitiveTypeGen3 = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);	
		SimpleNameGenerator nameGen3 = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen3 = new SingleVariableDeclarationGenerator(nameGen3, primitiveTypeGen3);		
		AssignmentExpressionForVariableGenerator statementGen3 =new AssignmentExpressionForVariableGenerator(variableGen3);
		
		// Setting the IfStatement
		IfStatementGenerator ifGen = new IfStatementGenerator(infixGen, statementGen, statementGen3);
		//ASTNodeGeneratorTestUtil.testBasicFunctionality(infixGen, 2);
		//ASTNodeGeneratorTestUtil.testBasicFunctionality(statementGen, 2);
		GeneratorTester.testExpectedCount(ifGen, 8);
	}	
}
