package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.InfixExpressionGenerator;
import edu.uiuc.astgen.basic.NumberLiteralGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;

import org.testorrery.GeneratorTester;


public class InfixExpressionGeneratorTest {

	@Test() public void testEnumerate3Values() {	
		PrimitiveTypeGenerator primitiveTypeGen = new PrimitiveTypeGenerator(
				PrimitiveType.BOOLEAN, PrimitiveType.BYTE);
		
		SimpleNameGenerator nameGen = new SimpleNameGenerator("v1");
		SingleVariableDeclarationGenerator variableGen = new SingleVariableDeclarationGenerator(nameGen, primitiveTypeGen);
		
		InfixExpressionGenerator infixGenerator = new InfixExpressionGenerator(variableGen);		
		GeneratorTester.testExpectedCount(
				infixGenerator, 2);			
		
	}	
}
