package edu.uiuc.astgen.test.basic;

import org.junit.*;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.PrimitiveType;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.basic.MethodDeclarationGenerator;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;

import org.testorrery.GeneratorTester;

public class InterfaceGeneratorTest {
	@Test() public void testBasicFunctionality() throws Exception {
		SimpleNameGenerator nameGen = new SimpleNameGenerator("interface1");
		ModifierGenerator visModGen = new ModifierGenerator(Modifier.ModifierKeyword.PUBLIC_KEYWORD,
				Modifier.ModifierKeyword.PRIVATE_KEYWORD);
		ModifierGenerator interfaceModGen = new ModifierGenerator((Modifier.ModifierKeyword)null,
				Modifier.ModifierKeyword.ABSTRACT_KEYWORD);
		ASTNodeChain<MethodDeclaration> methodSequenceGen = new ASTNodeChain<MethodDeclaration>();
		
		MethodDeclarationGenerator methodGen;		
		methodGen = new MethodDeclarationGenerator(new SimpleNameGenerator("method1"));
		methodGen.setReturnTypeGenerator(new PrimitiveTypeGenerator(PrimitiveType.INT));
		methodSequenceGen.add(methodGen);
		
		methodGen = new MethodDeclarationGenerator(new SimpleNameGenerator("method2"));
		methodGen.setReturnTypeGenerator(new PrimitiveTypeGenerator(PrimitiveType.LONG));
		methodSequenceGen.add(methodGen);
		
		ClassGenerator classGen = new ClassGenerator(nameGen);
		classGen.setVisibilityModifierGen(visModGen);
		classGen.setClassModifierGen(interfaceModGen);
		classGen.addBodyDeclarationGenerator(methodSequenceGen);
				
		GeneratorTester.testExpectedCount(classGen, 1 * 2 * 2 * 2);
	}
}
