package edu.uiuc.astgen.test.basic;

import org.junit.*;
import org.eclipse.jdt.core.dom.*;

import edu.uiuc.astgen.*;
import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;

import org.testorrery.GeneratorTester;

public class SingleVariableDeclarationGeneratorTest {

	@Test
	public void testBasicFunctionality() {
		SimpleNameGenerator nameGen = new SimpleNameGenerator("theVariable");
		PrimitiveTypeGenerator typeGen = new PrimitiveTypeGenerator(PrimitiveType.INT, 
				PrimitiveType.LONG);
		ModifierGenerator modGen = new ModifierGenerator((Modifier.ModifierKeyword)null,
				Modifier.ModifierKeyword.FINAL_KEYWORD);		
		
		SingleVariableDeclarationGenerator svdg = new SingleVariableDeclarationGenerator(nameGen, 
				typeGen, 
				modGen);
		
		GeneratorTester.testExpectedCount(svdg, 1 * 2 * 2);
	}
	
	@Test
	public void testEnumerate1Value() {
		SimpleNameGenerator nameGen = new SimpleNameGenerator("theVariable");
		PrimitiveTypeGenerator typeGen = new PrimitiveTypeGenerator(PrimitiveType.INT); //PrimitiveType.LONG
		ModifierGenerator modGen = new ModifierGenerator((Modifier.ModifierKeyword)null,
				Modifier.ModifierKeyword.FINAL_KEYWORD);		
		
		SingleVariableDeclarationGenerator svdg = new SingleVariableDeclarationGenerator(nameGen, 
				typeGen);
		
		GeneratorTester.testExpectedCount(svdg, 1 );
	}	
	
}
