package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.NumberLiteralGenerator;
import edu.uiuc.astgen.basic.StringLiteralGenerator;
import edu.uiuc.astgen.basic.SuperConstructorInvocationGenerator;

import org.testorrery.GeneratorTester;

public class SuperConstructorInvocationGeneratorTest {
	@Test
	public void OneParameter() {		
		NumberLiteralGenerator numberGen = new NumberLiteralGenerator(2, PrimitiveType.BYTE);
		SuperConstructorInvocationGenerator superConstructorInvocationGen = new SuperConstructorInvocationGenerator();	
		superConstructorInvocationGen.addArgumentGenerator(numberGen);
		GeneratorTester.testExpectedCount(superConstructorInvocationGen, 2);
	}
	
	@Test
	public void TwoParameters() {		
		NumberLiteralGenerator numberGen = new NumberLiteralGenerator(2, PrimitiveType.BYTE);
		StringLiteralGenerator stringGen = StringLiteralGenerator.getNewDefaultStringLiteralGenerator();
		SuperConstructorInvocationGenerator superConstructorInvocationGen = new SuperConstructorInvocationGenerator();	
		superConstructorInvocationGen.addArgumentGenerator(numberGen);
		superConstructorInvocationGen.addArgumentGenerator(stringGen);
		GeneratorTester.testExpectedCount(superConstructorInvocationGen, 4);
	}		
}
