package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.SimpleType;
import org.junit.Test;
import edu.uiuc.astgen.basic.ClassInstanceCreationGenerator;
import edu.uiuc.astgen.basic.StringLiteralGenerator;
import edu.uiuc.astgen.basic.ThrowStatementGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;
import org.testorrery.Chain;
import org.testorrery.GeneratorTester;

public class ThrowStatementGeneratorTest {
	AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
	
	@Test public void DefaulThrowStatement() {
		GeneratorTester.testExpectedCount(ThrowStatementGenerator.getNewDefaultThrowStatementGenerator(), 3);
	}
	
	@Test public void basicFunctionality() {
		Chain<SimpleType> chainSimpleType = new Chain<SimpleType>(ast.newSimpleType(ast.newSimpleName("Exception")), ast.newSimpleType(ast.newSimpleName("IOException")));		
		Chain<String> chainOfStrings = new Chain<String>();
		chainOfStrings.add("\"name1\"");
		chainOfStrings.add("\"name2\"");
		StringLiteralGenerator stringLiteralGen = new StringLiteralGenerator(chainOfStrings);
		ClassInstanceCreationGenerator classInstanceGen = new ClassInstanceCreationGenerator(chainSimpleType);
		classInstanceGen.addArgumentGenerator(stringLiteralGen);

		ThrowStatementGenerator throwStatementGen = new ThrowStatementGenerator(classInstanceGen);
		GeneratorTester.testExpectedCount(throwStatementGen, 4);
	}	
}
