package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.basic.VariableDeclarationStatementGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;
import org.testorrery.Chain;
import org.testorrery.GeneratorTester;

public class VariableDeclarationStatementGeneratorTest {

	@Test()
	public void basicFunctionality() {
		AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
		SimpleNameGenerator nameGen = new SimpleNameGenerator("theVariable");
		PrimitiveTypeGenerator typeGen = new PrimitiveTypeGenerator(PrimitiveType.INT,
				PrimitiveType.LONG);
		ModifierGenerator modGen = new ModifierGenerator((Modifier.ModifierKeyword) null,
				Modifier.ModifierKeyword.FINAL_KEYWORD);

		SingleVariableDeclarationGenerator svdg = new SingleVariableDeclarationGenerator(
				nameGen, typeGen, modGen);

		SimpleNameGenerator nameGen2 = new SimpleNameGenerator("i");
		VariableDeclarationStatementGenerator vdfg = new VariableDeclarationStatementGenerator(
				nameGen2, svdg);

		GeneratorTester.testExpectedCount(vdfg, 4);
	}
}
