package edu.uiuc.astgen.test.classrelationships;

import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.junit.*;

import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;

public class InheritanceTypeTest {
	TypeDeclaration a, b;
	
	@Before
	public void setUp() {
		a = new ClassGenerator("A").next();
		b = new ClassGenerator("B").next();
	}
		
	@Test
	public void testNoInheritance() {
		runTest(
				InheritanceType.NO_INHERITANCE, 
				"class A {\n}\n", 
				"class B {\n}\n");	
	}
	
	@Test
	public void testSubclass() {
		runTest(
				InheritanceType.SUBCLASS, 
				"class A {\n}\n", 
				"class B extends A {\n}\n");
	}
		
	void runTest(InheritanceType type, String expectedA, String expectedB) {		
		RelationshipSpecificationTest.testSpec(type, a, b, expectedA, expectedB);			
	}
}