package edu.uiuc.astgen.test.classrelationships;

import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.junit.*;

import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.classrelationships.LocationType;
import edu.uiuc.astgen.classrelationships.RelationshipDirection;

public class LocationTypeTest {
	TypeDeclaration a, b;
	
	@Before
	public void setUp() {
		a = new ClassGenerator("A").next();
		b = new ClassGenerator("B").next();
	}
		
	@Test
	public void testSeparate() {
		runTest(LocationType.SEPARATE, 
				RelationshipDirection.UNRELATED, 
				"class A {\n}\n", 
				"class B {\n}\n");
	}
	
	@Test
	public void testInner() {		
		runTest(LocationType.INNER, 
				RelationshipDirection.B_TO_A, 
				"class A {\nclass B {\n  }\n}\n", 
				"class B {\n}\n");
	}
	
	@Test
	public void testLocal() {		
		runTest(LocationType.LOCAL, 
				RelationshipDirection.B_TO_A, 
				"class A {\n  public void dummyMethod_A(){\nclass B {\n    }\n  }\n}\n", 
				"class B {\n}\n");
		
	}
	
	void runTest(LocationType type, RelationshipDirection expectedDirection, String expectedA, String expectedB) {		
		RelationshipSpecificationTest.testSpec(type, a, b, expectedA, expectedB);	
	}
}
