package edu.uiuc.astgen.test.classrelationships;

import java.util.List;

import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.junit.*;

import edu.uiuc.astgen.basic.ClassGenerator;
import edu.uiuc.astgen.basic.FieldDeclarationGenerator;
import edu.uiuc.astgen.classrelationships.LocationType;
import edu.uiuc.astgen.classrelationships.RelationshipBuilder;
import edu.uiuc.astgen.classrelationships.RelationshipSpecificationGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;
import edu.uiuc.astgen.classrelationships.MultiClassRelationshipGenerator;
import edu.uiuc.astgen.classrelationships.ReferenceType;
import edu.uiuc.astgen.classrelationships.RelationshipSpecification;
import org.testorrery.IGenerator;

public class MultiClassRelationshipGeneratorTest {

	@Test
	public void testBasicFunctionality() {
		ClassGenerator class1Gen = new ClassGenerator("A");
		class1Gen.addBodyDeclarationGenerator(new FieldDeclarationGenerator("f"));
				
		ClassGenerator class2Gen = new ClassGenerator("B");
		class2Gen.addBodyDeclarationGenerator(new FieldDeclarationGenerator("g"));
		
		ClassGenerator class3Gen = new ClassGenerator("C");
		class3Gen.addBodyDeclarationGenerator(new FieldDeclarationGenerator("h"));		
				
		MultiClassRelationshipGenerator.SpecificationCallback callback = new MultiClassRelationshipGenerator.SpecificationCallback() {
			public IGenerator<RelationshipSpecification> makeSpecificationGenerator() {
				RelationshipSpecificationGenerator crbg = new RelationshipSpecificationGenerator();
				crbg.setInheritance(InheritanceType.NO_INHERITANCE, InheritanceType.SUBCLASS);
				crbg.setLocation(LocationType.SEPARATE);
				crbg.setReference(ReferenceType.NO_REFERENCE);		
				crbg.setEnableReverse(false);
				
				return crbg;
			}
		};
		
		MultiClassRelationshipGenerator crg = new MultiClassRelationshipGenerator(callback, class1Gen, class2Gen, class3Gen);
		
		int i = 1;
		for (List<TypeDeclaration> list : crg) {
			System.out.println("LIST #" + i++ + " -----");
			for (TypeDeclaration typeDecl : list) {
				System.out.println("OBJECT ---");
				System.out.println(typeDecl);
			}			
		}
	}
	
}
