package edu.uiuc.astgen.test.classrelationships;

import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.junit.*;

import edu.uiuc.astgen.classrelationships.RelationshipBuilder;

/** 
 * Utility class used to test {@link RelationshipBuilder}s
 * 
 * @author Brett Daniel
 *
 */
public class RelationshipBuilderTest {
	
	/**
	 * Utility function used to test a given {@link RelationshipBuilder}
	 */
	public static void testBuilder(
			RelationshipBuilder builder, 
			TypeDeclaration a,
			TypeDeclaration b,
			String expectedA, 
			String expectedB) {
		
		builder.build(a, b);
		
		System.out.println(a.toString());		
		System.out.println(b.toString());
		
		Assert.assertEquals(expectedA, a.toString());
		Assert.assertEquals(expectedB, b.toString());
	}
}
