package edu.uiuc.astgen.test.classrelationships;

import org.junit.*;

import edu.uiuc.astgen.classrelationships.LocationType;
import edu.uiuc.astgen.classrelationships.RelationshipSpecificationGenerator;
import edu.uiuc.astgen.classrelationships.InheritanceType;
import edu.uiuc.astgen.classrelationships.ReferenceType;

import org.testorrery.GeneratorTester;

public class RelationshipSpecificationGeneratorTest {

	@Test
	public void testBasicFunctionality() {
		RelationshipSpecificationGenerator relSpecGen = new RelationshipSpecificationGenerator();
		relSpecGen.setLocation(LocationType.SEPARATE, LocationType.INNER);
		relSpecGen.setInheritance(InheritanceType.NO_INHERITANCE, InheritanceType.SUBCLASS);
		relSpecGen.setReference(ReferenceType.NO_REFERENCE, ReferenceType.FIELD_TYPE);		
		relSpecGen.setEnableReverse(false);
		
		GeneratorTester.testExpectedStrings(relSpecGen, 
			"SEPARATE UNRELATED\nNO_INHERITANCE UNRELATED\nNO_REFERENCE UNRELATED\n",
			"SEPARATE UNRELATED\nNO_INHERITANCE UNRELATED\nFIELD_TYPE B_TO_A\n",
			"SEPARATE UNRELATED\nSUBCLASS B_TO_A\nNO_REFERENCE UNRELATED\n",
			"SEPARATE UNRELATED\nSUBCLASS B_TO_A\nFIELD_TYPE B_TO_A\n",
			"INNER B_TO_A\nNO_INHERITANCE UNRELATED\nNO_REFERENCE UNRELATED\n",
			"INNER B_TO_A\nNO_INHERITANCE UNRELATED\nFIELD_TYPE B_TO_A\n",
			"INNER B_TO_A\nSUBCLASS B_TO_A\nNO_REFERENCE UNRELATED\n",
			"INNER B_TO_A\nSUBCLASS B_TO_A\nFIELD_TYPE B_TO_A\n");		
	}
	
	@Test
	public void testEnableReverse() {
		RelationshipSpecificationGenerator relSpecGen = new RelationshipSpecificationGenerator();
		// separate is not reversible, inner is
		relSpecGen.setLocation(LocationType.SEPARATE, LocationType.INNER);		
		relSpecGen.setEnableReverseLocation(true);
		
		GeneratorTester.testExpectedStrings(relSpecGen, 
			"SEPARATE UNRELATED\nNO_INHERITANCE UNRELATED\nNO_REFERENCE UNRELATED\n",
			"INNER B_TO_A\nNO_INHERITANCE UNRELATED\nNO_REFERENCE UNRELATED\n",
			"INNER A_TO_B\nNO_INHERITANCE UNRELATED\nNO_REFERENCE UNRELATED\n");
	}
	
}
