package edu.uiuc.astgen.test.fieldreferences;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.eclipse.jdt.core.dom.Type;
import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.junit.Test;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.basic.GetterSetterGenerator;
import edu.uiuc.astgen.basic.MultipleFieldDeclarationGenerator;
import edu.uiuc.astgen.fieldreferences.DualClassFieldGetterSetter;
import edu.uiuc.astgen.fieldreferences.DualClass2FieldsParentDeclarationGenerator;
import edu.uiuc.astgen.fieldreferences.FieldReferenceType;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;
import org.testorrery.Chain;
import org.testorrery.GeneratorTester;
import org.testorrery.IGenerator;

public class DualClassFieldGetterSetterTest {
	AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
	
	@Test
	public void testBasicFunctionality() {
		String classNameA = "A", classNameB = "B";
		TypeDeclaration typeDecl = ast.newTypeDeclaration();
		typeDecl.setName(ast.newSimpleName(classNameA));
//		IGenerator<FieldReferenceType> fieldRefTypeGen = new Chain<FieldReferenceType>(
//				FieldReferenceType.NEW_INSTANCE, 
//				FieldReferenceType.QUALIFIED_THIS, 
//				FieldReferenceType.THIS,
//				FieldReferenceType.UNQUALIFIED,
//				FieldReferenceType.SUPER);		
		
		GetterSetterGenerator getSetGen = new GetterSetterGenerator("field");
		getSetGen.setTypeGen(new ASTNodeChain<Type>(
				//ast.newPrimitiveType(PrimitiveType.INT),
				ast.newPrimitiveType(PrimitiveType.BOOLEAN)));				
		
		DualClassFieldGetterSetter typeGen = new DualClassFieldGetterSetter("A", "B", "field");
		typeGen.setGetterSetterGen(getSetGen);
		
				
		for (CompilationUnit cuDecl : typeGen) {
			System.out.println(cuDecl);
		}
		
		GeneratorTester.testExpectedCount(typeGen, 12 * 2 * 2 );
	}	
}
