package edu.uiuc.astgen.test.fieldreferences;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Type;
import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.junit.Test;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.basic.MultipleFieldDeclarationGenerator;
import edu.uiuc.astgen.fieldreferences.SingleClass2FieldsReferenceGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;

import org.testorrery.GeneratorTester;

public class SingleClass2FieldsReferenceGeneratorTest {
	AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
	
	@Test
	public void testBasicFunctionality() {
		TypeDeclaration typeA = ast.newTypeDeclaration();
		typeA.setName(ast.newSimpleName("A"));		
		
		MultipleFieldDeclarationGenerator multipleFieldDeclGen = new MultipleFieldDeclarationGenerator("f", "g", typeA, true);
		
		SingleClass2FieldsReferenceGenerator typeGen = new SingleClass2FieldsReferenceGenerator(multipleFieldDeclGen);
		
		for (TypeDeclaration typeDecl : typeGen) {
			System.out.println(typeDecl);
		}
		
		GeneratorTester.testExpectedCount(typeGen, 1908 * 2);
	}
	
	@Test
	public void testBasicFunctionality_With3FieldTypes() {
		TypeDeclaration typeA = ast.newTypeDeclaration();
		typeA.setName(ast.newSimpleName("A"));		
		
		MultipleFieldDeclarationGenerator multipleFieldDeclGen = new MultipleFieldDeclarationGenerator("f", "g", typeA, true);
		multipleFieldDeclGen.setTypeGen(new ASTNodeChain<Type>(
				ast.newSimpleType(ast.newSimpleName("Integer")),
				ast.newSimpleType(ast.newSimpleName("Boolean")),
				ast.newSimpleType(ast.newSimpleName("Object"))));		
		
		SingleClass2FieldsReferenceGenerator typeGen = new SingleClass2FieldsReferenceGenerator(multipleFieldDeclGen);
		
		for (TypeDeclaration typeDecl : typeGen) {
			System.out.println(typeDecl);
		}
		
		GeneratorTester.testExpectedCount(typeGen, 1908 * 3 * 2);
	}	
}
