package edu.uiuc.astgen.test.methodrelationships;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.Type;
import org.junit.*;

import edu.uiuc.astgen.ASTNodeChain;
import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.methodrelationships.MethodWithParameterReferenceGenerator;

import org.testorrery.GeneratorTester;

public class MethodWithParameterReferenceGeneratorTest {

	@Test
	public void testBasic() {
		AST ast = ASTNodeGeneratorBase.ast();
		SingleVariableDeclarationGenerator paramGen = new SingleVariableDeclarationGenerator("arg");
		paramGen.setTypeGen(new ASTNodeChain<Type>(
				ast.newSimpleType(ast.newSimpleName("Integer")),
				ast.newSimpleType(ast.newSimpleName("Boolean")),
				ast.newSimpleType(ast.newSimpleName("Object"))));
		MethodWithParameterReferenceGenerator methDeclGen = new MethodWithParameterReferenceGenerator("m", paramGen);
		
		GeneratorTester.testExpectedCount(methDeclGen, 1680);
	}
}
