package edu.uiuc.astgen.test.nestedexpressions;

import org.junit.*;

import edu.uiuc.astgen.nestedexpressions.ConditionalBuilderGenerator;
import edu.uiuc.astgen.nestedexpressions.OperandType;

public class ConditionalBuilderGeneratorTest {	
	
	@Test
	public void testObjectOperand() {
		ConditionalBuilderGenerator condGen = new ConditionalBuilderGenerator(OperandType.OBJECT);
		condGen.setLocationsAll();
		
		runTest(condGen,
			"target == dummy ? dummy : dummy",
			"dummy == dummy ? target : dummy",
			"dummy != dummy ? dummy : target",
			"target == dummy ? target : dummy",
			"target == dummy ? dummy : target",
			"dummy == dummy ? target : target",
			"target == dummy ? target : target");
	}
	
	@Test
	public void testBooleanOperand() {
		ConditionalBuilderGenerator condGen = new ConditionalBuilderGenerator(OperandType.BOOLEAN);
		condGen.setLocationsAll();
		
		runTest(condGen,
			"target ? dummy : dummy",
			"dummy ? target : dummy",
			"dummy ? dummy : target",
			"target ? target : dummy",
			"target ? dummy : target",
			"dummy ? target : target",
			"target ? target : target");
	}
	
	void runTest(ConditionalBuilderGenerator condGen, String... expectedExpressions) {
		BuilderTestUtil.runTest(condGen, "target", "dummy", expectedExpressions);
	}
}
