package edu.uiuc.astgen.test.nestedexpressions;

import org.junit.*;

import edu.uiuc.astgen.nestedexpressions.PostfixBuilderGenerator;
import edu.uiuc.astgen.nestedexpressions.OperandType;

public class PostfixBuilderGeneratorTest {	
	
	@Test
	public void objectExpressions() {
		PostfixBuilderGenerator gen = new PostfixBuilderGenerator(OperandType.OBJECT);
		runTest(gen); // no valid Postfix expressions for objects
	}

	@Test
	public void booleanExpressions() {
		PostfixBuilderGenerator gen = new PostfixBuilderGenerator(OperandType.BOOLEAN);
		runTest(gen); // no valid Postfix expressions for booleans
	}
	
	@Test
	public void numberExpressions() {
		PostfixBuilderGenerator gen = new PostfixBuilderGenerator(OperandType.NUMERIC);
		runTest(gen,
				"target++",
				"target--");
	}
	
	static void runTest(PostfixBuilderGenerator gen, String...expectedExpressions) {
		BuilderTestUtil.runTest(gen, "target", "dummy", expectedExpressions);
	}
}
