package edu.uiuc.astgen.test.nestedexpressions;

import org.junit.*;

import edu.uiuc.astgen.nestedexpressions.PrefixBuilderGenerator;
import edu.uiuc.astgen.nestedexpressions.OperandType;

public class PrefixBuilderGeneratorTest {	
	
	@Test
	public void objectExpressions() {
		PrefixBuilderGenerator gen = new PrefixBuilderGenerator(OperandType.OBJECT);
		runTest(gen); // no valid prefix expressions for objects
	}

	@Test
	public void booleanExpressions() {
		PrefixBuilderGenerator gen = new PrefixBuilderGenerator(OperandType.BOOLEAN);
		runTest(gen,
				"!target",
				"~target");
	}
	
	@Test
	public void numberExpressions() {
		PrefixBuilderGenerator gen = new PrefixBuilderGenerator(OperandType.NUMERIC);
		runTest(gen,
				"~target",
				"--target",
				"++target",
				"-target",
				"+target");
	}
	
	static void runTest(PrefixBuilderGenerator gen, String...expectedExpressions) {
		BuilderTestUtil.runTest(gen, "target", "dummy", expectedExpressions);
	}
}
