package edu.uiuc.astgen.test.statements;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.Statement;
import org.junit.*;

import edu.uiuc.astgen.statements.StatementWithExpressionBuilder;
import edu.uiuc.astgen.statements.StatementWithExpressionBuilderGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;
import org.testorrery.ConvertingGenerator;
import org.testorrery.GeneratorTester;
import org.testorrery.Literal;

public class StatementWithExpressionBuilderGeneratorTest {

	AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
	
	@Test
	public void testBasicFunctionality() {		
		final Expression target = ast.newSimpleName("targetExpression");
		StatementWithExpressionBuilderGenerator builderGen = StatementWithExpressionBuilderGenerator.allExpressionTypes();
		
		ConvertingGenerator<StatementWithExpressionBuilder, Statement> stmtGen = 
			new ConvertingGenerator<StatementWithExpressionBuilder, Statement>(builderGen) {
				@Override
				protected Statement convert(StatementWithExpressionBuilder original) {
					return original.build((Expression)ASTNode.copySubtree(ast, target));
				}
			};
		
		GeneratorTester.testExpectedStrings(stmtGen, 
				"targetExpression;\n",
				"Object o=targetExpression;\n",
				"if (targetExpression) {\n}\n",
				"while (targetExpression) {\n}\n"); //TODO: more statements
		
	}
}
